// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from interaction_msgs:srv/Query.idl
// generated code does not contain a copyright notice

#ifndef INTERACTION_MSGS__SRV__DETAIL__QUERY__STRUCT_HPP_
#define INTERACTION_MSGS__SRV__DETAIL__QUERY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__interaction_msgs__srv__Query_Request __attribute__((deprecated))
#else
# define DEPRECATED__interaction_msgs__srv__Query_Request __declspec(deprecated)
#endif

namespace interaction_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct Query_Request_
{
  using Type = Query_Request_<ContainerAllocator>;

  explicit Query_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->modes = 0;
      this->threshold = 0.0f;
      this->frequency = 0;
      this->current_episode = 0;
      this->last_queried_episode = 0;
    }
  }

  explicit Query_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->modes = 0;
      this->threshold = 0.0f;
      this->frequency = 0;
      this->current_episode = 0;
      this->last_queried_episode = 0;
    }
  }

  // field types and members
  using _modes_type =
    uint16_t;
  _modes_type modes;
  using _threshold_type =
    float;
  _threshold_type threshold;
  using _frequency_type =
    uint16_t;
  _frequency_type frequency;
  using _current_episode_type =
    uint16_t;
  _current_episode_type current_episode;
  using _last_queried_episode_type =
    uint16_t;
  _last_queried_episode_type last_queried_episode;
  using _last_rewards_type =
    std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>>;
  _last_rewards_type last_rewards;

  // setters for named parameter idiom
  Type & set__modes(
    const uint16_t & _arg)
  {
    this->modes = _arg;
    return *this;
  }
  Type & set__threshold(
    const float & _arg)
  {
    this->threshold = _arg;
    return *this;
  }
  Type & set__frequency(
    const uint16_t & _arg)
  {
    this->frequency = _arg;
    return *this;
  }
  Type & set__current_episode(
    const uint16_t & _arg)
  {
    this->current_episode = _arg;
    return *this;
  }
  Type & set__last_queried_episode(
    const uint16_t & _arg)
  {
    this->last_queried_episode = _arg;
    return *this;
  }
  Type & set__last_rewards(
    const std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>> & _arg)
  {
    this->last_rewards = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    interaction_msgs::srv::Query_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const interaction_msgs::srv::Query_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<interaction_msgs::srv::Query_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<interaction_msgs::srv::Query_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      interaction_msgs::srv::Query_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<interaction_msgs::srv::Query_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      interaction_msgs::srv::Query_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<interaction_msgs::srv::Query_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<interaction_msgs::srv::Query_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<interaction_msgs::srv::Query_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__interaction_msgs__srv__Query_Request
    std::shared_ptr<interaction_msgs::srv::Query_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__interaction_msgs__srv__Query_Request
    std::shared_ptr<interaction_msgs::srv::Query_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Query_Request_ & other) const
  {
    if (this->modes != other.modes) {
      return false;
    }
    if (this->threshold != other.threshold) {
      return false;
    }
    if (this->frequency != other.frequency) {
      return false;
    }
    if (this->current_episode != other.current_episode) {
      return false;
    }
    if (this->last_queried_episode != other.last_queried_episode) {
      return false;
    }
    if (this->last_rewards != other.last_rewards) {
      return false;
    }
    return true;
  }
  bool operator!=(const Query_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Query_Request_

// alias to use template instance with default allocator
using Query_Request =
  interaction_msgs::srv::Query_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace interaction_msgs


#ifndef _WIN32
# define DEPRECATED__interaction_msgs__srv__Query_Response __attribute__((deprecated))
#else
# define DEPRECATED__interaction_msgs__srv__Query_Response __declspec(deprecated)
#endif

namespace interaction_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct Query_Response_
{
  using Type = Query_Response_<ContainerAllocator>;

  explicit Query_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->interaction = false;
    }
  }

  explicit Query_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->interaction = false;
    }
  }

  // field types and members
  using _interaction_type =
    bool;
  _interaction_type interaction;

  // setters for named parameter idiom
  Type & set__interaction(
    const bool & _arg)
  {
    this->interaction = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    interaction_msgs::srv::Query_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const interaction_msgs::srv::Query_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<interaction_msgs::srv::Query_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<interaction_msgs::srv::Query_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      interaction_msgs::srv::Query_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<interaction_msgs::srv::Query_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      interaction_msgs::srv::Query_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<interaction_msgs::srv::Query_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<interaction_msgs::srv::Query_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<interaction_msgs::srv::Query_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__interaction_msgs__srv__Query_Response
    std::shared_ptr<interaction_msgs::srv::Query_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__interaction_msgs__srv__Query_Response
    std::shared_ptr<interaction_msgs::srv::Query_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Query_Response_ & other) const
  {
    if (this->interaction != other.interaction) {
      return false;
    }
    return true;
  }
  bool operator!=(const Query_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Query_Response_

// alias to use template instance with default allocator
using Query_Response =
  interaction_msgs::srv::Query_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace interaction_msgs

namespace interaction_msgs
{

namespace srv
{

struct Query
{
  using Request = interaction_msgs::srv::Query_Request;
  using Response = interaction_msgs::srv::Query_Response;
};

}  // namespace srv

}  // namespace interaction_msgs

#endif  // INTERACTION_MSGS__SRV__DETAIL__QUERY__STRUCT_HPP_
