# generated from rosidl_generator_py/resource/_idl.py.em
# with input from interaction_msgs:msg/OptimizerState.idl
# generated code does not contain a copyright notice


# Import statements for member types

# Member 'x_best'
import array  # noqa: E402, I100

import builtins  # noqa: E402, I100

import math  # noqa: E402, I100

import rosidl_parser.definition  # noqa: E402, I100


class Metaclass_OptimizerState(type):
    """Metaclass of message 'OptimizerState'."""

    _CREATE_ROS_MESSAGE = None
    _CONVERT_FROM_PY = None
    _CONVERT_TO_PY = None
    _DESTROY_ROS_MESSAGE = None
    _TYPE_SUPPORT = None

    __constants = {
    }

    @classmethod
    def __import_type_support__(cls):
        try:
            from rosidl_generator_py import import_type_support
            module = import_type_support('interaction_msgs')
        except ImportError:
            import logging
            import traceback
            logger = logging.getLogger(
                'interaction_msgs.msg.OptimizerState')
            logger.debug(
                'Failed to import needed modules for type support:\n' +
                traceback.format_exc())
        else:
            cls._CREATE_ROS_MESSAGE = module.create_ros_message_msg__msg__optimizer_state
            cls._CONVERT_FROM_PY = module.convert_from_py_msg__msg__optimizer_state
            cls._CONVERT_TO_PY = module.convert_to_py_msg__msg__optimizer_state
            cls._TYPE_SUPPORT = module.type_support_msg__msg__optimizer_state
            cls._DESTROY_ROS_MESSAGE = module.destroy_ros_message_msg__msg__optimizer_state

    @classmethod
    def __prepare__(cls, name, bases, **kwargs):
        # list constant names here so that they appear in the help text of
        # the message class under "Data and other attributes defined here:"
        # as well as populate each message instance
        return {
        }


class OptimizerState(metaclass=Metaclass_OptimizerState):
    """Message class 'OptimizerState'."""

    __slots__ = [
        '_current_state',
        '_current_episode',
        '_reward_best',
        '_x_best',
    ]

    _fields_and_field_types = {
        'current_state': 'string',
        'current_episode': 'int32',
        'reward_best': 'float',
        'x_best': 'sequence<float>',
    }

    SLOT_TYPES = (
        rosidl_parser.definition.UnboundedString(),  # noqa: E501
        rosidl_parser.definition.BasicType('int32'),  # noqa: E501
        rosidl_parser.definition.BasicType('float'),  # noqa: E501
        rosidl_parser.definition.UnboundedSequence(rosidl_parser.definition.BasicType('float')),  # noqa: E501
    )

    def __init__(self, **kwargs):
        assert all('_' + key in self.__slots__ for key in kwargs.keys()), \
            'Invalid arguments passed to constructor: %s' % \
            ', '.join(sorted(k for k in kwargs.keys() if '_' + k not in self.__slots__))
        self.current_state = kwargs.get('current_state', str())
        self.current_episode = kwargs.get('current_episode', int())
        self.reward_best = kwargs.get('reward_best', float())
        self.x_best = array.array('f', kwargs.get('x_best', []))

    def __repr__(self):
        typename = self.__class__.__module__.split('.')
        typename.pop()
        typename.append(self.__class__.__name__)
        args = []
        for s, t in zip(self.__slots__, self.SLOT_TYPES):
            field = getattr(self, s)
            fieldstr = repr(field)
            # We use Python array type for fields that can be directly stored
            # in them, and "normal" sequences for everything else.  If it is
            # a type that we store in an array, strip off the 'array' portion.
            if (
                isinstance(t, rosidl_parser.definition.AbstractSequence) and
                isinstance(t.value_type, rosidl_parser.definition.BasicType) and
                t.value_type.typename in ['float', 'double', 'int8', 'uint8', 'int16', 'uint16', 'int32', 'uint32', 'int64', 'uint64']
            ):
                if len(field) == 0:
                    fieldstr = '[]'
                else:
                    assert fieldstr.startswith('array(')
                    prefix = "array('X', "
                    suffix = ')'
                    fieldstr = fieldstr[len(prefix):-len(suffix)]
            args.append(s[1:] + '=' + fieldstr)
        return '%s(%s)' % ('.'.join(typename), ', '.join(args))

    def __eq__(self, other):
        if not isinstance(other, self.__class__):
            return False
        if self.current_state != other.current_state:
            return False
        if self.current_episode != other.current_episode:
            return False
        if self.reward_best != other.reward_best:
            return False
        if self.x_best != other.x_best:
            return False
        return True

    @classmethod
    def get_fields_and_field_types(cls):
        from copy import copy
        return copy(cls._fields_and_field_types)

    @builtins.property
    def current_state(self):
        """Message field 'current_state'."""
        return self._current_state

    @current_state.setter
    def current_state(self, value):
        if __debug__:
            assert \
                isinstance(value, str), \
                "The 'current_state' field must be of type 'str'"
        self._current_state = value

    @builtins.property
    def current_episode(self):
        """Message field 'current_episode'."""
        return self._current_episode

    @current_episode.setter
    def current_episode(self, value):
        if __debug__:
            assert \
                isinstance(value, int), \
                "The 'current_episode' field must be of type 'int'"
            assert value >= -2147483648 and value < 2147483648, \
                "The 'current_episode' field must be an integer in [-2147483648, 2147483647]"
        self._current_episode = value

    @builtins.property
    def reward_best(self):
        """Message field 'reward_best'."""
        return self._reward_best

    @reward_best.setter
    def reward_best(self, value):
        if __debug__:
            assert \
                isinstance(value, float), \
                "The 'reward_best' field must be of type 'float'"
            assert not (value < -3.402823466e+38 or value > 3.402823466e+38) or math.isinf(value), \
                "The 'reward_best' field must be a float in [-3.402823466e+38, 3.402823466e+38]"
        self._reward_best = value

    @builtins.property
    def x_best(self):
        """Message field 'x_best'."""
        return self._x_best

    @x_best.setter
    def x_best(self, value):
        if isinstance(value, array.array):
            assert value.typecode == 'f', \
                "The 'x_best' array.array() must have the type code of 'f'"
            self._x_best = value
            return
        if __debug__:
            from collections.abc import Sequence
            from collections.abc import Set
            from collections import UserList
            from collections import UserString
            assert \
                ((isinstance(value, Sequence) or
                  isinstance(value, Set) or
                  isinstance(value, UserList)) and
                 not isinstance(value, str) and
                 not isinstance(value, UserString) and
                 all(isinstance(v, float) for v in value) and
                 all(not (val < -3.402823466e+38 or val > 3.402823466e+38) or math.isinf(val) for val in value)), \
                "The 'x_best' field must be a set or sequence and each value of type 'float' and each float in [-340282346600000016151267322115014000640.000000, 340282346600000016151267322115014000640.000000]"
        self._x_best = array.array('f', value)
