# generated from rosidl_generator_py/resource/_idl.py.em
# with input from interaction_msgs:msg/UI2Opt.idl
# generated code does not contain a copyright notice


# Import statements for member types

# Member 'set_parameter_values'
import array  # noqa: E402, I100

import builtins  # noqa: E402, I100

import math  # noqa: E402, I100

import rosidl_parser.definition  # noqa: E402, I100


class Metaclass_UI2Opt(type):
    """Metaclass of message 'UI2Opt'."""

    _CREATE_ROS_MESSAGE = None
    _CONVERT_FROM_PY = None
    _CONVERT_TO_PY = None
    _DESTROY_ROS_MESSAGE = None
    _TYPE_SUPPORT = None

    __constants = {
    }

    @classmethod
    def __import_type_support__(cls):
        try:
            from rosidl_generator_py import import_type_support
            module = import_type_support('interaction_msgs')
        except ImportError:
            import logging
            import traceback
            logger = logging.getLogger(
                'interaction_msgs.msg.UI2Opt')
            logger.debug(
                'Failed to import needed modules for type support:\n' +
                traceback.format_exc())
        else:
            cls._CREATE_ROS_MESSAGE = module.create_ros_message_msg__msg__ui2_opt
            cls._CONVERT_FROM_PY = module.convert_from_py_msg__msg__ui2_opt
            cls._CONVERT_TO_PY = module.convert_to_py_msg__msg__ui2_opt
            cls._TYPE_SUPPORT = module.type_support_msg__msg__ui2_opt
            cls._DESTROY_ROS_MESSAGE = module.destroy_ros_message_msg__msg__ui2_opt

    @classmethod
    def __prepare__(cls, name, bases, **kwargs):
        # list constant names here so that they appear in the help text of
        # the message class under "Data and other attributes defined here:"
        # as well as populate each message instance
        return {
        }


class UI2Opt(metaclass=Metaclass_UI2Opt):
    """Message class 'UI2Opt'."""

    __slots__ = [
        '_fixed_parameters',
        '_set_parameter_values',
    ]

    _fields_and_field_types = {
        'fixed_parameters': 'sequence<boolean>',
        'set_parameter_values': 'sequence<float>',
    }

    SLOT_TYPES = (
        rosidl_parser.definition.UnboundedSequence(rosidl_parser.definition.BasicType('boolean')),  # noqa: E501
        rosidl_parser.definition.UnboundedSequence(rosidl_parser.definition.BasicType('float')),  # noqa: E501
    )

    def __init__(self, **kwargs):
        assert all('_' + key in self.__slots__ for key in kwargs.keys()), \
            'Invalid arguments passed to constructor: %s' % \
            ', '.join(sorted(k for k in kwargs.keys() if '_' + k not in self.__slots__))
        self.fixed_parameters = kwargs.get('fixed_parameters', [])
        self.set_parameter_values = array.array('f', kwargs.get('set_parameter_values', []))

    def __repr__(self):
        typename = self.__class__.__module__.split('.')
        typename.pop()
        typename.append(self.__class__.__name__)
        args = []
        for s, t in zip(self.__slots__, self.SLOT_TYPES):
            field = getattr(self, s)
            fieldstr = repr(field)
            # We use Python array type for fields that can be directly stored
            # in them, and "normal" sequences for everything else.  If it is
            # a type that we store in an array, strip off the 'array' portion.
            if (
                isinstance(t, rosidl_parser.definition.AbstractSequence) and
                isinstance(t.value_type, rosidl_parser.definition.BasicType) and
                t.value_type.typename in ['float', 'double', 'int8', 'uint8', 'int16', 'uint16', 'int32', 'uint32', 'int64', 'uint64']
            ):
                if len(field) == 0:
                    fieldstr = '[]'
                else:
                    assert fieldstr.startswith('array(')
                    prefix = "array('X', "
                    suffix = ')'
                    fieldstr = fieldstr[len(prefix):-len(suffix)]
            args.append(s[1:] + '=' + fieldstr)
        return '%s(%s)' % ('.'.join(typename), ', '.join(args))

    def __eq__(self, other):
        if not isinstance(other, self.__class__):
            return False
        if self.fixed_parameters != other.fixed_parameters:
            return False
        if self.set_parameter_values != other.set_parameter_values:
            return False
        return True

    @classmethod
    def get_fields_and_field_types(cls):
        from copy import copy
        return copy(cls._fields_and_field_types)

    @builtins.property
    def fixed_parameters(self):
        """Message field 'fixed_parameters'."""
        return self._fixed_parameters

    @fixed_parameters.setter
    def fixed_parameters(self, value):
        if __debug__:
            from collections.abc import Sequence
            from collections.abc import Set
            from collections import UserList
            from collections import UserString
            assert \
                ((isinstance(value, Sequence) or
                  isinstance(value, Set) or
                  isinstance(value, UserList)) and
                 not isinstance(value, str) and
                 not isinstance(value, UserString) and
                 all(isinstance(v, bool) for v in value) and
                 True), \
                "The 'fixed_parameters' field must be a set or sequence and each value of type 'bool'"
        self._fixed_parameters = value

    @builtins.property
    def set_parameter_values(self):
        """Message field 'set_parameter_values'."""
        return self._set_parameter_values

    @set_parameter_values.setter
    def set_parameter_values(self, value):
        if isinstance(value, array.array):
            assert value.typecode == 'f', \
                "The 'set_parameter_values' array.array() must have the type code of 'f'"
            self._set_parameter_values = value
            return
        if __debug__:
            from collections.abc import Sequence
            from collections.abc import Set
            from collections import UserList
            from collections import UserString
            assert \
                ((isinstance(value, Sequence) or
                  isinstance(value, Set) or
                  isinstance(value, UserList)) and
                 not isinstance(value, str) and
                 not isinstance(value, UserString) and
                 all(isinstance(v, float) for v in value) and
                 all(not (val < -3.402823466e+38 or val > 3.402823466e+38) or math.isinf(val) for val in value)), \
                "The 'set_parameter_values' field must be a set or sequence and each value of type 'float' and each float in [-340282346600000016151267322115014000640.000000, 340282346600000016151267322115014000640.000000]"
        self._set_parameter_values = array.array('f', value)
