// generated from rosidl_typesupport_fastrtps_c/resource/idl__type_support_c.cpp.em
// with input from interaction_msgs:msg/OptimizerState.idl
// generated code does not contain a copyright notice
#include "interaction_msgs/msg/detail/optimizer_state__rosidl_typesupport_fastrtps_c.h"


#include <cassert>
#include <limits>
#include <string>
#include "rosidl_typesupport_fastrtps_c/identifier.h"
#include "rosidl_typesupport_fastrtps_c/wstring_conversion.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "interaction_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
#include "interaction_msgs/msg/detail/optimizer_state__struct.h"
#include "interaction_msgs/msg/detail/optimizer_state__functions.h"
#include "fastcdr/Cdr.h"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif
#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// includes and forward declarations of message dependencies and their conversion functions

#if defined(__cplusplus)
extern "C"
{
#endif

#include "rosidl_runtime_c/primitives_sequence.h"  // x_best
#include "rosidl_runtime_c/primitives_sequence_functions.h"  // x_best
#include "rosidl_runtime_c/string.h"  // current_state
#include "rosidl_runtime_c/string_functions.h"  // current_state

// forward declare type support functions


using _OptimizerState__ros_msg_type = interaction_msgs__msg__OptimizerState;

static bool _OptimizerState__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  const _OptimizerState__ros_msg_type * ros_message = static_cast<const _OptimizerState__ros_msg_type *>(untyped_ros_message);
  // Field name: current_state
  {
    const rosidl_runtime_c__String * str = &ros_message->current_state;
    if (str->capacity == 0 || str->capacity <= str->size) {
      fprintf(stderr, "string capacity not greater than size\n");
      return false;
    }
    if (str->data[str->size] != '\0') {
      fprintf(stderr, "string not null-terminated\n");
      return false;
    }
    cdr << str->data;
  }

  // Field name: current_episode
  {
    cdr << ros_message->current_episode;
  }

  // Field name: reward_best
  {
    cdr << ros_message->reward_best;
  }

  // Field name: x_best
  {
    size_t size = ros_message->x_best.size;
    auto array_ptr = ros_message->x_best.data;
    cdr << static_cast<uint32_t>(size);
    cdr.serializeArray(array_ptr, size);
  }

  return true;
}

static bool _OptimizerState__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  _OptimizerState__ros_msg_type * ros_message = static_cast<_OptimizerState__ros_msg_type *>(untyped_ros_message);
  // Field name: current_state
  {
    std::string tmp;
    cdr >> tmp;
    if (!ros_message->current_state.data) {
      rosidl_runtime_c__String__init(&ros_message->current_state);
    }
    bool succeeded = rosidl_runtime_c__String__assign(
      &ros_message->current_state,
      tmp.c_str());
    if (!succeeded) {
      fprintf(stderr, "failed to assign string into field 'current_state'\n");
      return false;
    }
  }

  // Field name: current_episode
  {
    cdr >> ros_message->current_episode;
  }

  // Field name: reward_best
  {
    cdr >> ros_message->reward_best;
  }

  // Field name: x_best
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    if (ros_message->x_best.data) {
      rosidl_runtime_c__float__Sequence__fini(&ros_message->x_best);
    }
    if (!rosidl_runtime_c__float__Sequence__init(&ros_message->x_best, size)) {
      fprintf(stderr, "failed to create array for field 'x_best'");
      return false;
    }
    auto array_ptr = ros_message->x_best.data;
    cdr.deserializeArray(array_ptr, size);
  }

  return true;
}  // NOLINT(readability/fn_size)

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_interaction_msgs
size_t get_serialized_size_interaction_msgs__msg__OptimizerState(
  const void * untyped_ros_message,
  size_t current_alignment)
{
  const _OptimizerState__ros_msg_type * ros_message = static_cast<const _OptimizerState__ros_msg_type *>(untyped_ros_message);
  (void)ros_message;
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // field.name current_state
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message->current_state.size + 1);
  // field.name current_episode
  {
    size_t item_size = sizeof(ros_message->current_episode);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // field.name reward_best
  {
    size_t item_size = sizeof(ros_message->reward_best);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // field.name x_best
  {
    size_t array_size = ros_message->x_best.size;
    auto array_ptr = ros_message->x_best.data;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);
    (void)array_ptr;
    size_t item_size = sizeof(array_ptr[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

static uint32_t _OptimizerState__get_serialized_size(const void * untyped_ros_message)
{
  return static_cast<uint32_t>(
    get_serialized_size_interaction_msgs__msg__OptimizerState(
      untyped_ros_message, 0));
}

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_interaction_msgs
size_t max_serialized_size_interaction_msgs__msg__OptimizerState(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;

  // member: current_state
  {
    size_t array_size = 1;

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }
  // member: current_episode
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }
  // member: reward_best
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }
  // member: x_best
  {
    size_t array_size = 0;
    full_bounded = false;
    is_plain = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = interaction_msgs__msg__OptimizerState;
    is_plain =
      (
      offsetof(DataType, x_best) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static size_t _OptimizerState__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_interaction_msgs__msg__OptimizerState(
    full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}


static message_type_support_callbacks_t __callbacks_OptimizerState = {
  "interaction_msgs::msg",
  "OptimizerState",
  _OptimizerState__cdr_serialize,
  _OptimizerState__cdr_deserialize,
  _OptimizerState__get_serialized_size,
  _OptimizerState__max_serialized_size
};

static rosidl_message_type_support_t _OptimizerState__type_support = {
  rosidl_typesupport_fastrtps_c__identifier,
  &__callbacks_OptimizerState,
  get_message_typesupport_handle_function,
};

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, interaction_msgs, msg, OptimizerState)() {
  return &_OptimizerState__type_support;
}

#if defined(__cplusplus)
}
#endif
