// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from interaction_msgs:msg/OptimizerState.idl
// generated code does not contain a copyright notice

#ifndef INTERACTION_MSGS__MSG__DETAIL__OPTIMIZER_STATE__STRUCT_HPP_
#define INTERACTION_MSGS__MSG__DETAIL__OPTIMIZER_STATE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__interaction_msgs__msg__OptimizerState __attribute__((deprecated))
#else
# define DEPRECATED__interaction_msgs__msg__OptimizerState __declspec(deprecated)
#endif

namespace interaction_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct OptimizerState_
{
  using Type = OptimizerState_<ContainerAllocator>;

  explicit OptimizerState_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->current_state = "";
      this->current_episode = 0l;
      this->reward_best = 0.0f;
    }
  }

  explicit OptimizerState_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : current_state(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->current_state = "";
      this->current_episode = 0l;
      this->reward_best = 0.0f;
    }
  }

  // field types and members
  using _current_state_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _current_state_type current_state;
  using _current_episode_type =
    int32_t;
  _current_episode_type current_episode;
  using _reward_best_type =
    float;
  _reward_best_type reward_best;
  using _x_best_type =
    std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>>;
  _x_best_type x_best;

  // setters for named parameter idiom
  Type & set__current_state(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->current_state = _arg;
    return *this;
  }
  Type & set__current_episode(
    const int32_t & _arg)
  {
    this->current_episode = _arg;
    return *this;
  }
  Type & set__reward_best(
    const float & _arg)
  {
    this->reward_best = _arg;
    return *this;
  }
  Type & set__x_best(
    const std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>> & _arg)
  {
    this->x_best = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    interaction_msgs::msg::OptimizerState_<ContainerAllocator> *;
  using ConstRawPtr =
    const interaction_msgs::msg::OptimizerState_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<interaction_msgs::msg::OptimizerState_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<interaction_msgs::msg::OptimizerState_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      interaction_msgs::msg::OptimizerState_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<interaction_msgs::msg::OptimizerState_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      interaction_msgs::msg::OptimizerState_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<interaction_msgs::msg::OptimizerState_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<interaction_msgs::msg::OptimizerState_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<interaction_msgs::msg::OptimizerState_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__interaction_msgs__msg__OptimizerState
    std::shared_ptr<interaction_msgs::msg::OptimizerState_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__interaction_msgs__msg__OptimizerState
    std::shared_ptr<interaction_msgs::msg::OptimizerState_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const OptimizerState_ & other) const
  {
    if (this->current_state != other.current_state) {
      return false;
    }
    if (this->current_episode != other.current_episode) {
      return false;
    }
    if (this->reward_best != other.reward_best) {
      return false;
    }
    if (this->x_best != other.x_best) {
      return false;
    }
    return true;
  }
  bool operator!=(const OptimizerState_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct OptimizerState_

// alias to use template instance with default allocator
using OptimizerState =
  interaction_msgs::msg::OptimizerState_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace interaction_msgs

#endif  // INTERACTION_MSGS__MSG__DETAIL__OPTIMIZER_STATE__STRUCT_HPP_
