// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from interaction_msgs:msg/OptimizerState.idl
// generated code does not contain a copyright notice

#ifndef INTERACTION_MSGS__MSG__DETAIL__OPTIMIZER_STATE__TRAITS_HPP_
#define INTERACTION_MSGS__MSG__DETAIL__OPTIMIZER_STATE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "interaction_msgs/msg/detail/optimizer_state__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace interaction_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const OptimizerState & msg,
  std::ostream & out)
{
  out << "{";
  // member: current_state
  {
    out << "current_state: ";
    rosidl_generator_traits::value_to_yaml(msg.current_state, out);
    out << ", ";
  }

  // member: current_episode
  {
    out << "current_episode: ";
    rosidl_generator_traits::value_to_yaml(msg.current_episode, out);
    out << ", ";
  }

  // member: reward_best
  {
    out << "reward_best: ";
    rosidl_generator_traits::value_to_yaml(msg.reward_best, out);
    out << ", ";
  }

  // member: x_best
  {
    if (msg.x_best.size() == 0) {
      out << "x_best: []";
    } else {
      out << "x_best: [";
      size_t pending_items = msg.x_best.size();
      for (auto item : msg.x_best) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const OptimizerState & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: current_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "current_state: ";
    rosidl_generator_traits::value_to_yaml(msg.current_state, out);
    out << "\n";
  }

  // member: current_episode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "current_episode: ";
    rosidl_generator_traits::value_to_yaml(msg.current_episode, out);
    out << "\n";
  }

  // member: reward_best
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "reward_best: ";
    rosidl_generator_traits::value_to_yaml(msg.reward_best, out);
    out << "\n";
  }

  // member: x_best
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.x_best.size() == 0) {
      out << "x_best: []\n";
    } else {
      out << "x_best:\n";
      for (auto item : msg.x_best) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const OptimizerState & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace interaction_msgs

namespace rosidl_generator_traits
{

[[deprecated("use interaction_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const interaction_msgs::msg::OptimizerState & msg,
  std::ostream & out, size_t indentation = 0)
{
  interaction_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use interaction_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const interaction_msgs::msg::OptimizerState & msg)
{
  return interaction_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<interaction_msgs::msg::OptimizerState>()
{
  return "interaction_msgs::msg::OptimizerState";
}

template<>
inline const char * name<interaction_msgs::msg::OptimizerState>()
{
  return "interaction_msgs/msg/OptimizerState";
}

template<>
struct has_fixed_size<interaction_msgs::msg::OptimizerState>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<interaction_msgs::msg::OptimizerState>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<interaction_msgs::msg::OptimizerState>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // INTERACTION_MSGS__MSG__DETAIL__OPTIMIZER_STATE__TRAITS_HPP_
