// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from interaction_msgs:msg/TaskOrder.idl
// generated code does not contain a copyright notice
#include "interaction_msgs/msg/detail/task_order__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
interaction_msgs__msg__TaskOrder__init(interaction_msgs__msg__TaskOrder * msg)
{
  if (!msg) {
    return false;
  }
  // bla
  return true;
}

void
interaction_msgs__msg__TaskOrder__fini(interaction_msgs__msg__TaskOrder * msg)
{
  if (!msg) {
    return;
  }
  // bla
}

bool
interaction_msgs__msg__TaskOrder__are_equal(const interaction_msgs__msg__TaskOrder * lhs, const interaction_msgs__msg__TaskOrder * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // bla
  if (lhs->bla != rhs->bla) {
    return false;
  }
  return true;
}

bool
interaction_msgs__msg__TaskOrder__copy(
  const interaction_msgs__msg__TaskOrder * input,
  interaction_msgs__msg__TaskOrder * output)
{
  if (!input || !output) {
    return false;
  }
  // bla
  output->bla = input->bla;
  return true;
}

interaction_msgs__msg__TaskOrder *
interaction_msgs__msg__TaskOrder__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  interaction_msgs__msg__TaskOrder * msg = (interaction_msgs__msg__TaskOrder *)allocator.allocate(sizeof(interaction_msgs__msg__TaskOrder), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(interaction_msgs__msg__TaskOrder));
  bool success = interaction_msgs__msg__TaskOrder__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
interaction_msgs__msg__TaskOrder__destroy(interaction_msgs__msg__TaskOrder * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    interaction_msgs__msg__TaskOrder__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
interaction_msgs__msg__TaskOrder__Sequence__init(interaction_msgs__msg__TaskOrder__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  interaction_msgs__msg__TaskOrder * data = NULL;

  if (size) {
    data = (interaction_msgs__msg__TaskOrder *)allocator.zero_allocate(size, sizeof(interaction_msgs__msg__TaskOrder), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = interaction_msgs__msg__TaskOrder__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        interaction_msgs__msg__TaskOrder__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
interaction_msgs__msg__TaskOrder__Sequence__fini(interaction_msgs__msg__TaskOrder__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      interaction_msgs__msg__TaskOrder__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

interaction_msgs__msg__TaskOrder__Sequence *
interaction_msgs__msg__TaskOrder__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  interaction_msgs__msg__TaskOrder__Sequence * array = (interaction_msgs__msg__TaskOrder__Sequence *)allocator.allocate(sizeof(interaction_msgs__msg__TaskOrder__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = interaction_msgs__msg__TaskOrder__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
interaction_msgs__msg__TaskOrder__Sequence__destroy(interaction_msgs__msg__TaskOrder__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    interaction_msgs__msg__TaskOrder__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
interaction_msgs__msg__TaskOrder__Sequence__are_equal(const interaction_msgs__msg__TaskOrder__Sequence * lhs, const interaction_msgs__msg__TaskOrder__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!interaction_msgs__msg__TaskOrder__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
interaction_msgs__msg__TaskOrder__Sequence__copy(
  const interaction_msgs__msg__TaskOrder__Sequence * input,
  interaction_msgs__msg__TaskOrder__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(interaction_msgs__msg__TaskOrder);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    interaction_msgs__msg__TaskOrder * data =
      (interaction_msgs__msg__TaskOrder *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!interaction_msgs__msg__TaskOrder__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          interaction_msgs__msg__TaskOrder__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!interaction_msgs__msg__TaskOrder__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
