// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from interaction_msgs:msg/UI2Opt.idl
// generated code does not contain a copyright notice

#ifndef INTERACTION_MSGS__MSG__DETAIL__UI2_OPT__TRAITS_HPP_
#define INTERACTION_MSGS__MSG__DETAIL__UI2_OPT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "interaction_msgs/msg/detail/ui2_opt__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace interaction_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const UI2Opt & msg,
  std::ostream & out)
{
  out << "{";
  // member: fixed_parameters
  {
    if (msg.fixed_parameters.size() == 0) {
      out << "fixed_parameters: []";
    } else {
      out << "fixed_parameters: [";
      size_t pending_items = msg.fixed_parameters.size();
      for (auto item : msg.fixed_parameters) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: set_parameter_values
  {
    if (msg.set_parameter_values.size() == 0) {
      out << "set_parameter_values: []";
    } else {
      out << "set_parameter_values: [";
      size_t pending_items = msg.set_parameter_values.size();
      for (auto item : msg.set_parameter_values) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const UI2Opt & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: fixed_parameters
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.fixed_parameters.size() == 0) {
      out << "fixed_parameters: []\n";
    } else {
      out << "fixed_parameters:\n";
      for (auto item : msg.fixed_parameters) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: set_parameter_values
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.set_parameter_values.size() == 0) {
      out << "set_parameter_values: []\n";
    } else {
      out << "set_parameter_values:\n";
      for (auto item : msg.set_parameter_values) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const UI2Opt & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace interaction_msgs

namespace rosidl_generator_traits
{

[[deprecated("use interaction_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const interaction_msgs::msg::UI2Opt & msg,
  std::ostream & out, size_t indentation = 0)
{
  interaction_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use interaction_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const interaction_msgs::msg::UI2Opt & msg)
{
  return interaction_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<interaction_msgs::msg::UI2Opt>()
{
  return "interaction_msgs::msg::UI2Opt";
}

template<>
inline const char * name<interaction_msgs::msg::UI2Opt>()
{
  return "interaction_msgs/msg/UI2Opt";
}

template<>
struct has_fixed_size<interaction_msgs::msg::UI2Opt>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<interaction_msgs::msg::UI2Opt>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<interaction_msgs::msg::UI2Opt>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // INTERACTION_MSGS__MSG__DETAIL__UI2_OPT__TRAITS_HPP_
