// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from interaction_msgs:srv/Query.idl
// generated code does not contain a copyright notice

#ifndef INTERACTION_MSGS__SRV__DETAIL__QUERY__TRAITS_HPP_
#define INTERACTION_MSGS__SRV__DETAIL__QUERY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "interaction_msgs/srv/detail/query__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace interaction_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const Query_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: modes
  {
    out << "modes: ";
    rosidl_generator_traits::value_to_yaml(msg.modes, out);
    out << ", ";
  }

  // member: threshold
  {
    out << "threshold: ";
    rosidl_generator_traits::value_to_yaml(msg.threshold, out);
    out << ", ";
  }

  // member: frequency
  {
    out << "frequency: ";
    rosidl_generator_traits::value_to_yaml(msg.frequency, out);
    out << ", ";
  }

  // member: current_episode
  {
    out << "current_episode: ";
    rosidl_generator_traits::value_to_yaml(msg.current_episode, out);
    out << ", ";
  }

  // member: last_queried_episode
  {
    out << "last_queried_episode: ";
    rosidl_generator_traits::value_to_yaml(msg.last_queried_episode, out);
    out << ", ";
  }

  // member: last_rewards
  {
    if (msg.last_rewards.size() == 0) {
      out << "last_rewards: []";
    } else {
      out << "last_rewards: [";
      size_t pending_items = msg.last_rewards.size();
      for (auto item : msg.last_rewards) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Query_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: modes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "modes: ";
    rosidl_generator_traits::value_to_yaml(msg.modes, out);
    out << "\n";
  }

  // member: threshold
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "threshold: ";
    rosidl_generator_traits::value_to_yaml(msg.threshold, out);
    out << "\n";
  }

  // member: frequency
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "frequency: ";
    rosidl_generator_traits::value_to_yaml(msg.frequency, out);
    out << "\n";
  }

  // member: current_episode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "current_episode: ";
    rosidl_generator_traits::value_to_yaml(msg.current_episode, out);
    out << "\n";
  }

  // member: last_queried_episode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "last_queried_episode: ";
    rosidl_generator_traits::value_to_yaml(msg.last_queried_episode, out);
    out << "\n";
  }

  // member: last_rewards
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.last_rewards.size() == 0) {
      out << "last_rewards: []\n";
    } else {
      out << "last_rewards:\n";
      for (auto item : msg.last_rewards) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Query_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace interaction_msgs

namespace rosidl_generator_traits
{

[[deprecated("use interaction_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const interaction_msgs::srv::Query_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  interaction_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use interaction_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const interaction_msgs::srv::Query_Request & msg)
{
  return interaction_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<interaction_msgs::srv::Query_Request>()
{
  return "interaction_msgs::srv::Query_Request";
}

template<>
inline const char * name<interaction_msgs::srv::Query_Request>()
{
  return "interaction_msgs/srv/Query_Request";
}

template<>
struct has_fixed_size<interaction_msgs::srv::Query_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<interaction_msgs::srv::Query_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<interaction_msgs::srv::Query_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace interaction_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const Query_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: interaction
  {
    out << "interaction: ";
    rosidl_generator_traits::value_to_yaml(msg.interaction, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Query_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: interaction
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "interaction: ";
    rosidl_generator_traits::value_to_yaml(msg.interaction, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Query_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace interaction_msgs

namespace rosidl_generator_traits
{

[[deprecated("use interaction_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const interaction_msgs::srv::Query_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  interaction_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use interaction_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const interaction_msgs::srv::Query_Response & msg)
{
  return interaction_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<interaction_msgs::srv::Query_Response>()
{
  return "interaction_msgs::srv::Query_Response";
}

template<>
inline const char * name<interaction_msgs::srv::Query_Response>()
{
  return "interaction_msgs/srv/Query_Response";
}

template<>
struct has_fixed_size<interaction_msgs::srv::Query_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<interaction_msgs::srv::Query_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<interaction_msgs::srv::Query_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<interaction_msgs::srv::Query>()
{
  return "interaction_msgs::srv::Query";
}

template<>
inline const char * name<interaction_msgs::srv::Query>()
{
  return "interaction_msgs/srv/Query";
}

template<>
struct has_fixed_size<interaction_msgs::srv::Query>
  : std::integral_constant<
    bool,
    has_fixed_size<interaction_msgs::srv::Query_Request>::value &&
    has_fixed_size<interaction_msgs::srv::Query_Response>::value
  >
{
};

template<>
struct has_bounded_size<interaction_msgs::srv::Query>
  : std::integral_constant<
    bool,
    has_bounded_size<interaction_msgs::srv::Query_Request>::value &&
    has_bounded_size<interaction_msgs::srv::Query_Response>::value
  >
{
};

template<>
struct is_service<interaction_msgs::srv::Query>
  : std::true_type
{
};

template<>
struct is_service_request<interaction_msgs::srv::Query_Request>
  : std::true_type
{
};

template<>
struct is_service_response<interaction_msgs::srv::Query_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // INTERACTION_MSGS__SRV__DETAIL__QUERY__TRAITS_HPP_
