# generated from rosidl_generator_py/resource/_idl.py.em
# with input from interaction_msgs:srv/Query.idl
# generated code does not contain a copyright notice


# Import statements for member types

# Member 'last_rewards'
import array  # noqa: E402, I100

import builtins  # noqa: E402, I100

import math  # noqa: E402, I100

import rosidl_parser.definition  # noqa: E402, I100


class Metaclass_Query_Request(type):
    """Metaclass of message 'Query_Request'."""

    _CREATE_ROS_MESSAGE = None
    _CONVERT_FROM_PY = None
    _CONVERT_TO_PY = None
    _DESTROY_ROS_MESSAGE = None
    _TYPE_SUPPORT = None

    __constants = {
    }

    @classmethod
    def __import_type_support__(cls):
        try:
            from rosidl_generator_py import import_type_support
            module = import_type_support('interaction_msgs')
        except ImportError:
            import logging
            import traceback
            logger = logging.getLogger(
                'interaction_msgs.srv.Query_Request')
            logger.debug(
                'Failed to import needed modules for type support:\n' +
                traceback.format_exc())
        else:
            cls._CREATE_ROS_MESSAGE = module.create_ros_message_msg__srv__query__request
            cls._CONVERT_FROM_PY = module.convert_from_py_msg__srv__query__request
            cls._CONVERT_TO_PY = module.convert_to_py_msg__srv__query__request
            cls._TYPE_SUPPORT = module.type_support_msg__srv__query__request
            cls._DESTROY_ROS_MESSAGE = module.destroy_ros_message_msg__srv__query__request

    @classmethod
    def __prepare__(cls, name, bases, **kwargs):
        # list constant names here so that they appear in the help text of
        # the message class under "Data and other attributes defined here:"
        # as well as populate each message instance
        return {
        }


class Query_Request(metaclass=Metaclass_Query_Request):
    """Message class 'Query_Request'."""

    __slots__ = [
        '_modes',
        '_threshold',
        '_frequency',
        '_current_episode',
        '_last_queried_episode',
        '_last_rewards',
    ]

    _fields_and_field_types = {
        'modes': 'uint16',
        'threshold': 'float',
        'frequency': 'uint16',
        'current_episode': 'uint16',
        'last_queried_episode': 'uint16',
        'last_rewards': 'sequence<float>',
    }

    SLOT_TYPES = (
        rosidl_parser.definition.BasicType('uint16'),  # noqa: E501
        rosidl_parser.definition.BasicType('float'),  # noqa: E501
        rosidl_parser.definition.BasicType('uint16'),  # noqa: E501
        rosidl_parser.definition.BasicType('uint16'),  # noqa: E501
        rosidl_parser.definition.BasicType('uint16'),  # noqa: E501
        rosidl_parser.definition.UnboundedSequence(rosidl_parser.definition.BasicType('float')),  # noqa: E501
    )

    def __init__(self, **kwargs):
        assert all('_' + key in self.__slots__ for key in kwargs.keys()), \
            'Invalid arguments passed to constructor: %s' % \
            ', '.join(sorted(k for k in kwargs.keys() if '_' + k not in self.__slots__))
        self.modes = kwargs.get('modes', int())
        self.threshold = kwargs.get('threshold', float())
        self.frequency = kwargs.get('frequency', int())
        self.current_episode = kwargs.get('current_episode', int())
        self.last_queried_episode = kwargs.get('last_queried_episode', int())
        self.last_rewards = array.array('f', kwargs.get('last_rewards', []))

    def __repr__(self):
        typename = self.__class__.__module__.split('.')
        typename.pop()
        typename.append(self.__class__.__name__)
        args = []
        for s, t in zip(self.__slots__, self.SLOT_TYPES):
            field = getattr(self, s)
            fieldstr = repr(field)
            # We use Python array type for fields that can be directly stored
            # in them, and "normal" sequences for everything else.  If it is
            # a type that we store in an array, strip off the 'array' portion.
            if (
                isinstance(t, rosidl_parser.definition.AbstractSequence) and
                isinstance(t.value_type, rosidl_parser.definition.BasicType) and
                t.value_type.typename in ['float', 'double', 'int8', 'uint8', 'int16', 'uint16', 'int32', 'uint32', 'int64', 'uint64']
            ):
                if len(field) == 0:
                    fieldstr = '[]'
                else:
                    assert fieldstr.startswith('array(')
                    prefix = "array('X', "
                    suffix = ')'
                    fieldstr = fieldstr[len(prefix):-len(suffix)]
            args.append(s[1:] + '=' + fieldstr)
        return '%s(%s)' % ('.'.join(typename), ', '.join(args))

    def __eq__(self, other):
        if not isinstance(other, self.__class__):
            return False
        if self.modes != other.modes:
            return False
        if self.threshold != other.threshold:
            return False
        if self.frequency != other.frequency:
            return False
        if self.current_episode != other.current_episode:
            return False
        if self.last_queried_episode != other.last_queried_episode:
            return False
        if self.last_rewards != other.last_rewards:
            return False
        return True

    @classmethod
    def get_fields_and_field_types(cls):
        from copy import copy
        return copy(cls._fields_and_field_types)

    @builtins.property
    def modes(self):
        """Message field 'modes'."""
        return self._modes

    @modes.setter
    def modes(self, value):
        if __debug__:
            assert \
                isinstance(value, int), \
                "The 'modes' field must be of type 'int'"
            assert value >= 0 and value < 65536, \
                "The 'modes' field must be an unsigned integer in [0, 65535]"
        self._modes = value

    @builtins.property
    def threshold(self):
        """Message field 'threshold'."""
        return self._threshold

    @threshold.setter
    def threshold(self, value):
        if __debug__:
            assert \
                isinstance(value, float), \
                "The 'threshold' field must be of type 'float'"
            assert not (value < -3.402823466e+38 or value > 3.402823466e+38) or math.isinf(value), \
                "The 'threshold' field must be a float in [-3.402823466e+38, 3.402823466e+38]"
        self._threshold = value

    @builtins.property
    def frequency(self):
        """Message field 'frequency'."""
        return self._frequency

    @frequency.setter
    def frequency(self, value):
        if __debug__:
            assert \
                isinstance(value, int), \
                "The 'frequency' field must be of type 'int'"
            assert value >= 0 and value < 65536, \
                "The 'frequency' field must be an unsigned integer in [0, 65535]"
        self._frequency = value

    @builtins.property
    def current_episode(self):
        """Message field 'current_episode'."""
        return self._current_episode

    @current_episode.setter
    def current_episode(self, value):
        if __debug__:
            assert \
                isinstance(value, int), \
                "The 'current_episode' field must be of type 'int'"
            assert value >= 0 and value < 65536, \
                "The 'current_episode' field must be an unsigned integer in [0, 65535]"
        self._current_episode = value

    @builtins.property
    def last_queried_episode(self):
        """Message field 'last_queried_episode'."""
        return self._last_queried_episode

    @last_queried_episode.setter
    def last_queried_episode(self, value):
        if __debug__:
            assert \
                isinstance(value, int), \
                "The 'last_queried_episode' field must be of type 'int'"
            assert value >= 0 and value < 65536, \
                "The 'last_queried_episode' field must be an unsigned integer in [0, 65535]"
        self._last_queried_episode = value

    @builtins.property
    def last_rewards(self):
        """Message field 'last_rewards'."""
        return self._last_rewards

    @last_rewards.setter
    def last_rewards(self, value):
        if isinstance(value, array.array):
            assert value.typecode == 'f', \
                "The 'last_rewards' array.array() must have the type code of 'f'"
            self._last_rewards = value
            return
        if __debug__:
            from collections.abc import Sequence
            from collections.abc import Set
            from collections import UserList
            from collections import UserString
            assert \
                ((isinstance(value, Sequence) or
                  isinstance(value, Set) or
                  isinstance(value, UserList)) and
                 not isinstance(value, str) and
                 not isinstance(value, UserString) and
                 all(isinstance(v, float) for v in value) and
                 all(not (val < -3.402823466e+38 or val > 3.402823466e+38) or math.isinf(val) for val in value)), \
                "The 'last_rewards' field must be a set or sequence and each value of type 'float' and each float in [-340282346600000016151267322115014000640.000000, 340282346600000016151267322115014000640.000000]"
        self._last_rewards = array.array('f', value)


# Import statements for member types

# already imported above
# import builtins

# already imported above
# import rosidl_parser.definition


class Metaclass_Query_Response(type):
    """Metaclass of message 'Query_Response'."""

    _CREATE_ROS_MESSAGE = None
    _CONVERT_FROM_PY = None
    _CONVERT_TO_PY = None
    _DESTROY_ROS_MESSAGE = None
    _TYPE_SUPPORT = None

    __constants = {
    }

    @classmethod
    def __import_type_support__(cls):
        try:
            from rosidl_generator_py import import_type_support
            module = import_type_support('interaction_msgs')
        except ImportError:
            import logging
            import traceback
            logger = logging.getLogger(
                'interaction_msgs.srv.Query_Response')
            logger.debug(
                'Failed to import needed modules for type support:\n' +
                traceback.format_exc())
        else:
            cls._CREATE_ROS_MESSAGE = module.create_ros_message_msg__srv__query__response
            cls._CONVERT_FROM_PY = module.convert_from_py_msg__srv__query__response
            cls._CONVERT_TO_PY = module.convert_to_py_msg__srv__query__response
            cls._TYPE_SUPPORT = module.type_support_msg__srv__query__response
            cls._DESTROY_ROS_MESSAGE = module.destroy_ros_message_msg__srv__query__response

    @classmethod
    def __prepare__(cls, name, bases, **kwargs):
        # list constant names here so that they appear in the help text of
        # the message class under "Data and other attributes defined here:"
        # as well as populate each message instance
        return {
        }


class Query_Response(metaclass=Metaclass_Query_Response):
    """Message class 'Query_Response'."""

    __slots__ = [
        '_interaction',
    ]

    _fields_and_field_types = {
        'interaction': 'boolean',
    }

    SLOT_TYPES = (
        rosidl_parser.definition.BasicType('boolean'),  # noqa: E501
    )

    def __init__(self, **kwargs):
        assert all('_' + key in self.__slots__ for key in kwargs.keys()), \
            'Invalid arguments passed to constructor: %s' % \
            ', '.join(sorted(k for k in kwargs.keys() if '_' + k not in self.__slots__))
        self.interaction = kwargs.get('interaction', bool())

    def __repr__(self):
        typename = self.__class__.__module__.split('.')
        typename.pop()
        typename.append(self.__class__.__name__)
        args = []
        for s, t in zip(self.__slots__, self.SLOT_TYPES):
            field = getattr(self, s)
            fieldstr = repr(field)
            # We use Python array type for fields that can be directly stored
            # in them, and "normal" sequences for everything else.  If it is
            # a type that we store in an array, strip off the 'array' portion.
            if (
                isinstance(t, rosidl_parser.definition.AbstractSequence) and
                isinstance(t.value_type, rosidl_parser.definition.BasicType) and
                t.value_type.typename in ['float', 'double', 'int8', 'uint8', 'int16', 'uint16', 'int32', 'uint32', 'int64', 'uint64']
            ):
                if len(field) == 0:
                    fieldstr = '[]'
                else:
                    assert fieldstr.startswith('array(')
                    prefix = "array('X', "
                    suffix = ')'
                    fieldstr = fieldstr[len(prefix):-len(suffix)]
            args.append(s[1:] + '=' + fieldstr)
        return '%s(%s)' % ('.'.join(typename), ', '.join(args))

    def __eq__(self, other):
        if not isinstance(other, self.__class__):
            return False
        if self.interaction != other.interaction:
            return False
        return True

    @classmethod
    def get_fields_and_field_types(cls):
        from copy import copy
        return copy(cls._fields_and_field_types)

    @builtins.property
    def interaction(self):
        """Message field 'interaction'."""
        return self._interaction

    @interaction.setter
    def interaction(self, value):
        if __debug__:
            assert \
                isinstance(value, bool), \
                "The 'interaction' field must be of type 'bool'"
        self._interaction = value


class Metaclass_Query(type):
    """Metaclass of service 'Query'."""

    _TYPE_SUPPORT = None

    @classmethod
    def __import_type_support__(cls):
        try:
            from rosidl_generator_py import import_type_support
            module = import_type_support('interaction_msgs')
        except ImportError:
            import logging
            import traceback
            logger = logging.getLogger(
                'interaction_msgs.srv.Query')
            logger.debug(
                'Failed to import needed modules for type support:\n' +
                traceback.format_exc())
        else:
            cls._TYPE_SUPPORT = module.type_support_srv__srv__query

            from interaction_msgs.srv import _query
            if _query.Metaclass_Query_Request._TYPE_SUPPORT is None:
                _query.Metaclass_Query_Request.__import_type_support__()
            if _query.Metaclass_Query_Response._TYPE_SUPPORT is None:
                _query.Metaclass_Query_Response.__import_type_support__()


class Query(metaclass=Metaclass_Query):
    from interaction_msgs.srv._query import Query_Request as Request
    from interaction_msgs.srv._query import Query_Response as Response

    def __init__(self):
        raise NotImplementedError('Service classes can not be instantiated')
