// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from interaction_msgs:msg/TaskOrder.idl
// generated code does not contain a copyright notice

#ifndef INTERACTION_MSGS__MSG__DETAIL__TASK_ORDER__FUNCTIONS_H_
#define INTERACTION_MSGS__MSG__DETAIL__TASK_ORDER__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "interaction_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "interaction_msgs/msg/detail/task_order__struct.h"

/// Initialize msg/TaskOrder message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * interaction_msgs__msg__TaskOrder
 * )) before or use
 * interaction_msgs__msg__TaskOrder__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
bool
interaction_msgs__msg__TaskOrder__init(interaction_msgs__msg__TaskOrder * msg);

/// Finalize msg/TaskOrder message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
void
interaction_msgs__msg__TaskOrder__fini(interaction_msgs__msg__TaskOrder * msg);

/// Create msg/TaskOrder message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * interaction_msgs__msg__TaskOrder__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
interaction_msgs__msg__TaskOrder *
interaction_msgs__msg__TaskOrder__create();

/// Destroy msg/TaskOrder message.
/**
 * It calls
 * interaction_msgs__msg__TaskOrder__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
void
interaction_msgs__msg__TaskOrder__destroy(interaction_msgs__msg__TaskOrder * msg);

/// Check for msg/TaskOrder message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
bool
interaction_msgs__msg__TaskOrder__are_equal(const interaction_msgs__msg__TaskOrder * lhs, const interaction_msgs__msg__TaskOrder * rhs);

/// Copy a msg/TaskOrder message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
bool
interaction_msgs__msg__TaskOrder__copy(
  const interaction_msgs__msg__TaskOrder * input,
  interaction_msgs__msg__TaskOrder * output);

/// Initialize array of msg/TaskOrder messages.
/**
 * It allocates the memory for the number of elements and calls
 * interaction_msgs__msg__TaskOrder__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
bool
interaction_msgs__msg__TaskOrder__Sequence__init(interaction_msgs__msg__TaskOrder__Sequence * array, size_t size);

/// Finalize array of msg/TaskOrder messages.
/**
 * It calls
 * interaction_msgs__msg__TaskOrder__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
void
interaction_msgs__msg__TaskOrder__Sequence__fini(interaction_msgs__msg__TaskOrder__Sequence * array);

/// Create array of msg/TaskOrder messages.
/**
 * It allocates the memory for the array and calls
 * interaction_msgs__msg__TaskOrder__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
interaction_msgs__msg__TaskOrder__Sequence *
interaction_msgs__msg__TaskOrder__Sequence__create(size_t size);

/// Destroy array of msg/TaskOrder messages.
/**
 * It calls
 * interaction_msgs__msg__TaskOrder__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
void
interaction_msgs__msg__TaskOrder__Sequence__destroy(interaction_msgs__msg__TaskOrder__Sequence * array);

/// Check for msg/TaskOrder message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
bool
interaction_msgs__msg__TaskOrder__Sequence__are_equal(const interaction_msgs__msg__TaskOrder__Sequence * lhs, const interaction_msgs__msg__TaskOrder__Sequence * rhs);

/// Copy an array of msg/TaskOrder messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
bool
interaction_msgs__msg__TaskOrder__Sequence__copy(
  const interaction_msgs__msg__TaskOrder__Sequence * input,
  interaction_msgs__msg__TaskOrder__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // INTERACTION_MSGS__MSG__DETAIL__TASK_ORDER__FUNCTIONS_H_
