// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from interaction_msgs:srv/Task.idl
// generated code does not contain a copyright notice
#include "interaction_msgs/srv/detail/task__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `x_next`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
interaction_msgs__srv__Task_Request__init(interaction_msgs__srv__Task_Request * msg)
{
  if (!msg) {
    return false;
  }
  // reward_return
  // nr_dim
  // nr_parameter
  // x_next
  if (!rosidl_runtime_c__float__Sequence__init(&msg->x_next, 0)) {
    interaction_msgs__srv__Task_Request__fini(msg);
    return false;
  }
  return true;
}

void
interaction_msgs__srv__Task_Request__fini(interaction_msgs__srv__Task_Request * msg)
{
  if (!msg) {
    return;
  }
  // reward_return
  // nr_dim
  // nr_parameter
  // x_next
  rosidl_runtime_c__float__Sequence__fini(&msg->x_next);
}

bool
interaction_msgs__srv__Task_Request__are_equal(const interaction_msgs__srv__Task_Request * lhs, const interaction_msgs__srv__Task_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // reward_return
  if (lhs->reward_return != rhs->reward_return) {
    return false;
  }
  // nr_dim
  if (lhs->nr_dim != rhs->nr_dim) {
    return false;
  }
  // nr_parameter
  if (lhs->nr_parameter != rhs->nr_parameter) {
    return false;
  }
  // x_next
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->x_next), &(rhs->x_next)))
  {
    return false;
  }
  return true;
}

bool
interaction_msgs__srv__Task_Request__copy(
  const interaction_msgs__srv__Task_Request * input,
  interaction_msgs__srv__Task_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // reward_return
  output->reward_return = input->reward_return;
  // nr_dim
  output->nr_dim = input->nr_dim;
  // nr_parameter
  output->nr_parameter = input->nr_parameter;
  // x_next
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->x_next), &(output->x_next)))
  {
    return false;
  }
  return true;
}

interaction_msgs__srv__Task_Request *
interaction_msgs__srv__Task_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  interaction_msgs__srv__Task_Request * msg = (interaction_msgs__srv__Task_Request *)allocator.allocate(sizeof(interaction_msgs__srv__Task_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(interaction_msgs__srv__Task_Request));
  bool success = interaction_msgs__srv__Task_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
interaction_msgs__srv__Task_Request__destroy(interaction_msgs__srv__Task_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    interaction_msgs__srv__Task_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
interaction_msgs__srv__Task_Request__Sequence__init(interaction_msgs__srv__Task_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  interaction_msgs__srv__Task_Request * data = NULL;

  if (size) {
    data = (interaction_msgs__srv__Task_Request *)allocator.zero_allocate(size, sizeof(interaction_msgs__srv__Task_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = interaction_msgs__srv__Task_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        interaction_msgs__srv__Task_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
interaction_msgs__srv__Task_Request__Sequence__fini(interaction_msgs__srv__Task_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      interaction_msgs__srv__Task_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

interaction_msgs__srv__Task_Request__Sequence *
interaction_msgs__srv__Task_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  interaction_msgs__srv__Task_Request__Sequence * array = (interaction_msgs__srv__Task_Request__Sequence *)allocator.allocate(sizeof(interaction_msgs__srv__Task_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = interaction_msgs__srv__Task_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
interaction_msgs__srv__Task_Request__Sequence__destroy(interaction_msgs__srv__Task_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    interaction_msgs__srv__Task_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
interaction_msgs__srv__Task_Request__Sequence__are_equal(const interaction_msgs__srv__Task_Request__Sequence * lhs, const interaction_msgs__srv__Task_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!interaction_msgs__srv__Task_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
interaction_msgs__srv__Task_Request__Sequence__copy(
  const interaction_msgs__srv__Task_Request__Sequence * input,
  interaction_msgs__srv__Task_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(interaction_msgs__srv__Task_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    interaction_msgs__srv__Task_Request * data =
      (interaction_msgs__srv__Task_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!interaction_msgs__srv__Task_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          interaction_msgs__srv__Task_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!interaction_msgs__srv__Task_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `x_observed`
// already included above
// #include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
interaction_msgs__srv__Task_Response__init(interaction_msgs__srv__Task_Response * msg)
{
  if (!msg) {
    return false;
  }
  // x_observed
  if (!rosidl_runtime_c__float__Sequence__init(&msg->x_observed, 0)) {
    interaction_msgs__srv__Task_Response__fini(msg);
    return false;
  }
  // reward
  return true;
}

void
interaction_msgs__srv__Task_Response__fini(interaction_msgs__srv__Task_Response * msg)
{
  if (!msg) {
    return;
  }
  // x_observed
  rosidl_runtime_c__float__Sequence__fini(&msg->x_observed);
  // reward
}

bool
interaction_msgs__srv__Task_Response__are_equal(const interaction_msgs__srv__Task_Response * lhs, const interaction_msgs__srv__Task_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // x_observed
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->x_observed), &(rhs->x_observed)))
  {
    return false;
  }
  // reward
  if (lhs->reward != rhs->reward) {
    return false;
  }
  return true;
}

bool
interaction_msgs__srv__Task_Response__copy(
  const interaction_msgs__srv__Task_Response * input,
  interaction_msgs__srv__Task_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // x_observed
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->x_observed), &(output->x_observed)))
  {
    return false;
  }
  // reward
  output->reward = input->reward;
  return true;
}

interaction_msgs__srv__Task_Response *
interaction_msgs__srv__Task_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  interaction_msgs__srv__Task_Response * msg = (interaction_msgs__srv__Task_Response *)allocator.allocate(sizeof(interaction_msgs__srv__Task_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(interaction_msgs__srv__Task_Response));
  bool success = interaction_msgs__srv__Task_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
interaction_msgs__srv__Task_Response__destroy(interaction_msgs__srv__Task_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    interaction_msgs__srv__Task_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
interaction_msgs__srv__Task_Response__Sequence__init(interaction_msgs__srv__Task_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  interaction_msgs__srv__Task_Response * data = NULL;

  if (size) {
    data = (interaction_msgs__srv__Task_Response *)allocator.zero_allocate(size, sizeof(interaction_msgs__srv__Task_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = interaction_msgs__srv__Task_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        interaction_msgs__srv__Task_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
interaction_msgs__srv__Task_Response__Sequence__fini(interaction_msgs__srv__Task_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      interaction_msgs__srv__Task_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

interaction_msgs__srv__Task_Response__Sequence *
interaction_msgs__srv__Task_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  interaction_msgs__srv__Task_Response__Sequence * array = (interaction_msgs__srv__Task_Response__Sequence *)allocator.allocate(sizeof(interaction_msgs__srv__Task_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = interaction_msgs__srv__Task_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
interaction_msgs__srv__Task_Response__Sequence__destroy(interaction_msgs__srv__Task_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    interaction_msgs__srv__Task_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
interaction_msgs__srv__Task_Response__Sequence__are_equal(const interaction_msgs__srv__Task_Response__Sequence * lhs, const interaction_msgs__srv__Task_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!interaction_msgs__srv__Task_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
interaction_msgs__srv__Task_Response__Sequence__copy(
  const interaction_msgs__srv__Task_Response__Sequence * input,
  interaction_msgs__srv__Task_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(interaction_msgs__srv__Task_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    interaction_msgs__srv__Task_Response * data =
      (interaction_msgs__srv__Task_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!interaction_msgs__srv__Task_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          interaction_msgs__srv__Task_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!interaction_msgs__srv__Task_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
