// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from interaction_msgs:srv/Task.idl
// generated code does not contain a copyright notice

#ifndef INTERACTION_MSGS__SRV__DETAIL__TASK__STRUCT_HPP_
#define INTERACTION_MSGS__SRV__DETAIL__TASK__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__interaction_msgs__srv__Task_Request __attribute__((deprecated))
#else
# define DEPRECATED__interaction_msgs__srv__Task_Request __declspec(deprecated)
#endif

namespace interaction_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct Task_Request_
{
  using Type = Task_Request_<ContainerAllocator>;

  explicit Task_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->reward_return = false;
      this->nr_dim = 0;
      this->nr_parameter = 0;
    }
  }

  explicit Task_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->reward_return = false;
      this->nr_dim = 0;
      this->nr_parameter = 0;
    }
  }

  // field types and members
  using _reward_return_type =
    bool;
  _reward_return_type reward_return;
  using _nr_dim_type =
    uint16_t;
  _nr_dim_type nr_dim;
  using _nr_parameter_type =
    uint16_t;
  _nr_parameter_type nr_parameter;
  using _x_next_type =
    std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>>;
  _x_next_type x_next;

  // setters for named parameter idiom
  Type & set__reward_return(
    const bool & _arg)
  {
    this->reward_return = _arg;
    return *this;
  }
  Type & set__nr_dim(
    const uint16_t & _arg)
  {
    this->nr_dim = _arg;
    return *this;
  }
  Type & set__nr_parameter(
    const uint16_t & _arg)
  {
    this->nr_parameter = _arg;
    return *this;
  }
  Type & set__x_next(
    const std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>> & _arg)
  {
    this->x_next = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    interaction_msgs::srv::Task_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const interaction_msgs::srv::Task_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<interaction_msgs::srv::Task_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<interaction_msgs::srv::Task_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      interaction_msgs::srv::Task_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<interaction_msgs::srv::Task_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      interaction_msgs::srv::Task_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<interaction_msgs::srv::Task_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<interaction_msgs::srv::Task_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<interaction_msgs::srv::Task_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__interaction_msgs__srv__Task_Request
    std::shared_ptr<interaction_msgs::srv::Task_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__interaction_msgs__srv__Task_Request
    std::shared_ptr<interaction_msgs::srv::Task_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Task_Request_ & other) const
  {
    if (this->reward_return != other.reward_return) {
      return false;
    }
    if (this->nr_dim != other.nr_dim) {
      return false;
    }
    if (this->nr_parameter != other.nr_parameter) {
      return false;
    }
    if (this->x_next != other.x_next) {
      return false;
    }
    return true;
  }
  bool operator!=(const Task_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Task_Request_

// alias to use template instance with default allocator
using Task_Request =
  interaction_msgs::srv::Task_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace interaction_msgs


#ifndef _WIN32
# define DEPRECATED__interaction_msgs__srv__Task_Response __attribute__((deprecated))
#else
# define DEPRECATED__interaction_msgs__srv__Task_Response __declspec(deprecated)
#endif

namespace interaction_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct Task_Response_
{
  using Type = Task_Response_<ContainerAllocator>;

  explicit Task_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->reward = 0.0f;
    }
  }

  explicit Task_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->reward = 0.0f;
    }
  }

  // field types and members
  using _x_observed_type =
    std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>>;
  _x_observed_type x_observed;
  using _reward_type =
    float;
  _reward_type reward;

  // setters for named parameter idiom
  Type & set__x_observed(
    const std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>> & _arg)
  {
    this->x_observed = _arg;
    return *this;
  }
  Type & set__reward(
    const float & _arg)
  {
    this->reward = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    interaction_msgs::srv::Task_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const interaction_msgs::srv::Task_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<interaction_msgs::srv::Task_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<interaction_msgs::srv::Task_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      interaction_msgs::srv::Task_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<interaction_msgs::srv::Task_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      interaction_msgs::srv::Task_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<interaction_msgs::srv::Task_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<interaction_msgs::srv::Task_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<interaction_msgs::srv::Task_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__interaction_msgs__srv__Task_Response
    std::shared_ptr<interaction_msgs::srv::Task_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__interaction_msgs__srv__Task_Response
    std::shared_ptr<interaction_msgs::srv::Task_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Task_Response_ & other) const
  {
    if (this->x_observed != other.x_observed) {
      return false;
    }
    if (this->reward != other.reward) {
      return false;
    }
    return true;
  }
  bool operator!=(const Task_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Task_Response_

// alias to use template instance with default allocator
using Task_Response =
  interaction_msgs::srv::Task_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace interaction_msgs

namespace interaction_msgs
{

namespace srv
{

struct Task
{
  using Request = interaction_msgs::srv::Task_Request;
  using Response = interaction_msgs::srv::Task_Response;
};

}  // namespace srv

}  // namespace interaction_msgs

#endif  // INTERACTION_MSGS__SRV__DETAIL__TASK__STRUCT_HPP_
