# generated from rosidl_generator_py/resource/_idl.py.em
# with input from interaction_msgs:srv/Task.idl
# generated code does not contain a copyright notice


# Import statements for member types

# Member 'x_next'
import array  # noqa: E402, I100

import builtins  # noqa: E402, I100

import math  # noqa: E402, I100

import rosidl_parser.definition  # noqa: E402, I100


class Metaclass_Task_Request(type):
    """Metaclass of message 'Task_Request'."""

    _CREATE_ROS_MESSAGE = None
    _CONVERT_FROM_PY = None
    _CONVERT_TO_PY = None
    _DESTROY_ROS_MESSAGE = None
    _TYPE_SUPPORT = None

    __constants = {
    }

    @classmethod
    def __import_type_support__(cls):
        try:
            from rosidl_generator_py import import_type_support
            module = import_type_support('interaction_msgs')
        except ImportError:
            import logging
            import traceback
            logger = logging.getLogger(
                'interaction_msgs.srv.Task_Request')
            logger.debug(
                'Failed to import needed modules for type support:\n' +
                traceback.format_exc())
        else:
            cls._CREATE_ROS_MESSAGE = module.create_ros_message_msg__srv__task__request
            cls._CONVERT_FROM_PY = module.convert_from_py_msg__srv__task__request
            cls._CONVERT_TO_PY = module.convert_to_py_msg__srv__task__request
            cls._TYPE_SUPPORT = module.type_support_msg__srv__task__request
            cls._DESTROY_ROS_MESSAGE = module.destroy_ros_message_msg__srv__task__request

    @classmethod
    def __prepare__(cls, name, bases, **kwargs):
        # list constant names here so that they appear in the help text of
        # the message class under "Data and other attributes defined here:"
        # as well as populate each message instance
        return {
        }


class Task_Request(metaclass=Metaclass_Task_Request):
    """Message class 'Task_Request'."""

    __slots__ = [
        '_reward_return',
        '_nr_dim',
        '_nr_parameter',
        '_x_next',
    ]

    _fields_and_field_types = {
        'reward_return': 'boolean',
        'nr_dim': 'uint16',
        'nr_parameter': 'uint16',
        'x_next': 'sequence<float>',
    }

    SLOT_TYPES = (
        rosidl_parser.definition.BasicType('boolean'),  # noqa: E501
        rosidl_parser.definition.BasicType('uint16'),  # noqa: E501
        rosidl_parser.definition.BasicType('uint16'),  # noqa: E501
        rosidl_parser.definition.UnboundedSequence(rosidl_parser.definition.BasicType('float')),  # noqa: E501
    )

    def __init__(self, **kwargs):
        assert all('_' + key in self.__slots__ for key in kwargs.keys()), \
            'Invalid arguments passed to constructor: %s' % \
            ', '.join(sorted(k for k in kwargs.keys() if '_' + k not in self.__slots__))
        self.reward_return = kwargs.get('reward_return', bool())
        self.nr_dim = kwargs.get('nr_dim', int())
        self.nr_parameter = kwargs.get('nr_parameter', int())
        self.x_next = array.array('f', kwargs.get('x_next', []))

    def __repr__(self):
        typename = self.__class__.__module__.split('.')
        typename.pop()
        typename.append(self.__class__.__name__)
        args = []
        for s, t in zip(self.__slots__, self.SLOT_TYPES):
            field = getattr(self, s)
            fieldstr = repr(field)
            # We use Python array type for fields that can be directly stored
            # in them, and "normal" sequences for everything else.  If it is
            # a type that we store in an array, strip off the 'array' portion.
            if (
                isinstance(t, rosidl_parser.definition.AbstractSequence) and
                isinstance(t.value_type, rosidl_parser.definition.BasicType) and
                t.value_type.typename in ['float', 'double', 'int8', 'uint8', 'int16', 'uint16', 'int32', 'uint32', 'int64', 'uint64']
            ):
                if len(field) == 0:
                    fieldstr = '[]'
                else:
                    assert fieldstr.startswith('array(')
                    prefix = "array('X', "
                    suffix = ')'
                    fieldstr = fieldstr[len(prefix):-len(suffix)]
            args.append(s[1:] + '=' + fieldstr)
        return '%s(%s)' % ('.'.join(typename), ', '.join(args))

    def __eq__(self, other):
        if not isinstance(other, self.__class__):
            return False
        if self.reward_return != other.reward_return:
            return False
        if self.nr_dim != other.nr_dim:
            return False
        if self.nr_parameter != other.nr_parameter:
            return False
        if self.x_next != other.x_next:
            return False
        return True

    @classmethod
    def get_fields_and_field_types(cls):
        from copy import copy
        return copy(cls._fields_and_field_types)

    @builtins.property
    def reward_return(self):
        """Message field 'reward_return'."""
        return self._reward_return

    @reward_return.setter
    def reward_return(self, value):
        if __debug__:
            assert \
                isinstance(value, bool), \
                "The 'reward_return' field must be of type 'bool'"
        self._reward_return = value

    @builtins.property
    def nr_dim(self):
        """Message field 'nr_dim'."""
        return self._nr_dim

    @nr_dim.setter
    def nr_dim(self, value):
        if __debug__:
            assert \
                isinstance(value, int), \
                "The 'nr_dim' field must be of type 'int'"
            assert value >= 0 and value < 65536, \
                "The 'nr_dim' field must be an unsigned integer in [0, 65535]"
        self._nr_dim = value

    @builtins.property
    def nr_parameter(self):
        """Message field 'nr_parameter'."""
        return self._nr_parameter

    @nr_parameter.setter
    def nr_parameter(self, value):
        if __debug__:
            assert \
                isinstance(value, int), \
                "The 'nr_parameter' field must be of type 'int'"
            assert value >= 0 and value < 65536, \
                "The 'nr_parameter' field must be an unsigned integer in [0, 65535]"
        self._nr_parameter = value

    @builtins.property
    def x_next(self):
        """Message field 'x_next'."""
        return self._x_next

    @x_next.setter
    def x_next(self, value):
        if isinstance(value, array.array):
            assert value.typecode == 'f', \
                "The 'x_next' array.array() must have the type code of 'f'"
            self._x_next = value
            return
        if __debug__:
            from collections.abc import Sequence
            from collections.abc import Set
            from collections import UserList
            from collections import UserString
            assert \
                ((isinstance(value, Sequence) or
                  isinstance(value, Set) or
                  isinstance(value, UserList)) and
                 not isinstance(value, str) and
                 not isinstance(value, UserString) and
                 all(isinstance(v, float) for v in value) and
                 all(not (val < -3.402823466e+38 or val > 3.402823466e+38) or math.isinf(val) for val in value)), \
                "The 'x_next' field must be a set or sequence and each value of type 'float' and each float in [-340282346600000016151267322115014000640.000000, 340282346600000016151267322115014000640.000000]"
        self._x_next = array.array('f', value)


# Import statements for member types

# Member 'x_observed'
# already imported above
# import array

# already imported above
# import builtins

# already imported above
# import math

# already imported above
# import rosidl_parser.definition


class Metaclass_Task_Response(type):
    """Metaclass of message 'Task_Response'."""

    _CREATE_ROS_MESSAGE = None
    _CONVERT_FROM_PY = None
    _CONVERT_TO_PY = None
    _DESTROY_ROS_MESSAGE = None
    _TYPE_SUPPORT = None

    __constants = {
    }

    @classmethod
    def __import_type_support__(cls):
        try:
            from rosidl_generator_py import import_type_support
            module = import_type_support('interaction_msgs')
        except ImportError:
            import logging
            import traceback
            logger = logging.getLogger(
                'interaction_msgs.srv.Task_Response')
            logger.debug(
                'Failed to import needed modules for type support:\n' +
                traceback.format_exc())
        else:
            cls._CREATE_ROS_MESSAGE = module.create_ros_message_msg__srv__task__response
            cls._CONVERT_FROM_PY = module.convert_from_py_msg__srv__task__response
            cls._CONVERT_TO_PY = module.convert_to_py_msg__srv__task__response
            cls._TYPE_SUPPORT = module.type_support_msg__srv__task__response
            cls._DESTROY_ROS_MESSAGE = module.destroy_ros_message_msg__srv__task__response

    @classmethod
    def __prepare__(cls, name, bases, **kwargs):
        # list constant names here so that they appear in the help text of
        # the message class under "Data and other attributes defined here:"
        # as well as populate each message instance
        return {
        }


class Task_Response(metaclass=Metaclass_Task_Response):
    """Message class 'Task_Response'."""

    __slots__ = [
        '_x_observed',
        '_reward',
    ]

    _fields_and_field_types = {
        'x_observed': 'sequence<float>',
        'reward': 'float',
    }

    SLOT_TYPES = (
        rosidl_parser.definition.UnboundedSequence(rosidl_parser.definition.BasicType('float')),  # noqa: E501
        rosidl_parser.definition.BasicType('float'),  # noqa: E501
    )

    def __init__(self, **kwargs):
        assert all('_' + key in self.__slots__ for key in kwargs.keys()), \
            'Invalid arguments passed to constructor: %s' % \
            ', '.join(sorted(k for k in kwargs.keys() if '_' + k not in self.__slots__))
        self.x_observed = array.array('f', kwargs.get('x_observed', []))
        self.reward = kwargs.get('reward', float())

    def __repr__(self):
        typename = self.__class__.__module__.split('.')
        typename.pop()
        typename.append(self.__class__.__name__)
        args = []
        for s, t in zip(self.__slots__, self.SLOT_TYPES):
            field = getattr(self, s)
            fieldstr = repr(field)
            # We use Python array type for fields that can be directly stored
            # in them, and "normal" sequences for everything else.  If it is
            # a type that we store in an array, strip off the 'array' portion.
            if (
                isinstance(t, rosidl_parser.definition.AbstractSequence) and
                isinstance(t.value_type, rosidl_parser.definition.BasicType) and
                t.value_type.typename in ['float', 'double', 'int8', 'uint8', 'int16', 'uint16', 'int32', 'uint32', 'int64', 'uint64']
            ):
                if len(field) == 0:
                    fieldstr = '[]'
                else:
                    assert fieldstr.startswith('array(')
                    prefix = "array('X', "
                    suffix = ')'
                    fieldstr = fieldstr[len(prefix):-len(suffix)]
            args.append(s[1:] + '=' + fieldstr)
        return '%s(%s)' % ('.'.join(typename), ', '.join(args))

    def __eq__(self, other):
        if not isinstance(other, self.__class__):
            return False
        if self.x_observed != other.x_observed:
            return False
        if self.reward != other.reward:
            return False
        return True

    @classmethod
    def get_fields_and_field_types(cls):
        from copy import copy
        return copy(cls._fields_and_field_types)

    @builtins.property
    def x_observed(self):
        """Message field 'x_observed'."""
        return self._x_observed

    @x_observed.setter
    def x_observed(self, value):
        if isinstance(value, array.array):
            assert value.typecode == 'f', \
                "The 'x_observed' array.array() must have the type code of 'f'"
            self._x_observed = value
            return
        if __debug__:
            from collections.abc import Sequence
            from collections.abc import Set
            from collections import UserList
            from collections import UserString
            assert \
                ((isinstance(value, Sequence) or
                  isinstance(value, Set) or
                  isinstance(value, UserList)) and
                 not isinstance(value, str) and
                 not isinstance(value, UserString) and
                 all(isinstance(v, float) for v in value) and
                 all(not (val < -3.402823466e+38 or val > 3.402823466e+38) or math.isinf(val) for val in value)), \
                "The 'x_observed' field must be a set or sequence and each value of type 'float' and each float in [-340282346600000016151267322115014000640.000000, 340282346600000016151267322115014000640.000000]"
        self._x_observed = array.array('f', value)

    @builtins.property
    def reward(self):
        """Message field 'reward'."""
        return self._reward

    @reward.setter
    def reward(self, value):
        if __debug__:
            assert \
                isinstance(value, float), \
                "The 'reward' field must be of type 'float'"
            assert not (value < -3.402823466e+38 or value > 3.402823466e+38) or math.isinf(value), \
                "The 'reward' field must be a float in [-3.402823466e+38, 3.402823466e+38]"
        self._reward = value


class Metaclass_Task(type):
    """Metaclass of service 'Task'."""

    _TYPE_SUPPORT = None

    @classmethod
    def __import_type_support__(cls):
        try:
            from rosidl_generator_py import import_type_support
            module = import_type_support('interaction_msgs')
        except ImportError:
            import logging
            import traceback
            logger = logging.getLogger(
                'interaction_msgs.srv.Task')
            logger.debug(
                'Failed to import needed modules for type support:\n' +
                traceback.format_exc())
        else:
            cls._TYPE_SUPPORT = module.type_support_srv__srv__task

            from interaction_msgs.srv import _task
            if _task.Metaclass_Task_Request._TYPE_SUPPORT is None:
                _task.Metaclass_Task_Request.__import_type_support__()
            if _task.Metaclass_Task_Response._TYPE_SUPPORT is None:
                _task.Metaclass_Task_Response.__import_type_support__()


class Task(metaclass=Metaclass_Task):
    from interaction_msgs.srv._task import Task_Request as Request
    from interaction_msgs.srv._task import Task_Response as Response

    def __init__(self):
        raise NotImplementedError('Service classes can not be instantiated')
