// generated from rosidl_typesupport_fastrtps_c/resource/idl__type_support_c.cpp.em
// with input from interaction_msgs:srv/Query.idl
// generated code does not contain a copyright notice
#include "interaction_msgs/srv/detail/query__rosidl_typesupport_fastrtps_c.h"


#include <cassert>
#include <limits>
#include <string>
#include "rosidl_typesupport_fastrtps_c/identifier.h"
#include "rosidl_typesupport_fastrtps_c/wstring_conversion.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "interaction_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
#include "interaction_msgs/srv/detail/query__struct.h"
#include "interaction_msgs/srv/detail/query__functions.h"
#include "fastcdr/Cdr.h"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif
#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// includes and forward declarations of message dependencies and their conversion functions

#if defined(__cplusplus)
extern "C"
{
#endif

#include "rosidl_runtime_c/primitives_sequence.h"  // last_rewards
#include "rosidl_runtime_c/primitives_sequence_functions.h"  // last_rewards

// forward declare type support functions


using _Query_Request__ros_msg_type = interaction_msgs__srv__Query_Request;

static bool _Query_Request__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  const _Query_Request__ros_msg_type * ros_message = static_cast<const _Query_Request__ros_msg_type *>(untyped_ros_message);
  // Field name: modes
  {
    cdr << ros_message->modes;
  }

  // Field name: threshold
  {
    cdr << ros_message->threshold;
  }

  // Field name: frequency
  {
    cdr << ros_message->frequency;
  }

  // Field name: current_episode
  {
    cdr << ros_message->current_episode;
  }

  // Field name: last_queried_episode
  {
    cdr << ros_message->last_queried_episode;
  }

  // Field name: last_rewards
  {
    size_t size = ros_message->last_rewards.size;
    auto array_ptr = ros_message->last_rewards.data;
    cdr << static_cast<uint32_t>(size);
    cdr.serializeArray(array_ptr, size);
  }

  return true;
}

static bool _Query_Request__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  _Query_Request__ros_msg_type * ros_message = static_cast<_Query_Request__ros_msg_type *>(untyped_ros_message);
  // Field name: modes
  {
    cdr >> ros_message->modes;
  }

  // Field name: threshold
  {
    cdr >> ros_message->threshold;
  }

  // Field name: frequency
  {
    cdr >> ros_message->frequency;
  }

  // Field name: current_episode
  {
    cdr >> ros_message->current_episode;
  }

  // Field name: last_queried_episode
  {
    cdr >> ros_message->last_queried_episode;
  }

  // Field name: last_rewards
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    if (ros_message->last_rewards.data) {
      rosidl_runtime_c__float__Sequence__fini(&ros_message->last_rewards);
    }
    if (!rosidl_runtime_c__float__Sequence__init(&ros_message->last_rewards, size)) {
      fprintf(stderr, "failed to create array for field 'last_rewards'");
      return false;
    }
    auto array_ptr = ros_message->last_rewards.data;
    cdr.deserializeArray(array_ptr, size);
  }

  return true;
}  // NOLINT(readability/fn_size)

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_interaction_msgs
size_t get_serialized_size_interaction_msgs__srv__Query_Request(
  const void * untyped_ros_message,
  size_t current_alignment)
{
  const _Query_Request__ros_msg_type * ros_message = static_cast<const _Query_Request__ros_msg_type *>(untyped_ros_message);
  (void)ros_message;
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // field.name modes
  {
    size_t item_size = sizeof(ros_message->modes);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // field.name threshold
  {
    size_t item_size = sizeof(ros_message->threshold);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // field.name frequency
  {
    size_t item_size = sizeof(ros_message->frequency);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // field.name current_episode
  {
    size_t item_size = sizeof(ros_message->current_episode);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // field.name last_queried_episode
  {
    size_t item_size = sizeof(ros_message->last_queried_episode);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // field.name last_rewards
  {
    size_t array_size = ros_message->last_rewards.size;
    auto array_ptr = ros_message->last_rewards.data;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);
    (void)array_ptr;
    size_t item_size = sizeof(array_ptr[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

static uint32_t _Query_Request__get_serialized_size(const void * untyped_ros_message)
{
  return static_cast<uint32_t>(
    get_serialized_size_interaction_msgs__srv__Query_Request(
      untyped_ros_message, 0));
}

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_interaction_msgs
size_t max_serialized_size_interaction_msgs__srv__Query_Request(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;

  // member: modes
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint16_t);
    current_alignment += array_size * sizeof(uint16_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint16_t));
  }
  // member: threshold
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }
  // member: frequency
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint16_t);
    current_alignment += array_size * sizeof(uint16_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint16_t));
  }
  // member: current_episode
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint16_t);
    current_alignment += array_size * sizeof(uint16_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint16_t));
  }
  // member: last_queried_episode
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint16_t);
    current_alignment += array_size * sizeof(uint16_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint16_t));
  }
  // member: last_rewards
  {
    size_t array_size = 0;
    full_bounded = false;
    is_plain = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = interaction_msgs__srv__Query_Request;
    is_plain =
      (
      offsetof(DataType, last_rewards) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static size_t _Query_Request__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_interaction_msgs__srv__Query_Request(
    full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}


static message_type_support_callbacks_t __callbacks_Query_Request = {
  "interaction_msgs::srv",
  "Query_Request",
  _Query_Request__cdr_serialize,
  _Query_Request__cdr_deserialize,
  _Query_Request__get_serialized_size,
  _Query_Request__max_serialized_size
};

static rosidl_message_type_support_t _Query_Request__type_support = {
  rosidl_typesupport_fastrtps_c__identifier,
  &__callbacks_Query_Request,
  get_message_typesupport_handle_function,
};

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, interaction_msgs, srv, Query_Request)() {
  return &_Query_Request__type_support;
}

#if defined(__cplusplus)
}
#endif

// already included above
// #include <cassert>
// already included above
// #include <limits>
// already included above
// #include <string>
// already included above
// #include "rosidl_typesupport_fastrtps_c/identifier.h"
// already included above
// #include "rosidl_typesupport_fastrtps_c/wstring_conversion.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
// already included above
// #include "interaction_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
// already included above
// #include "interaction_msgs/srv/detail/query__struct.h"
// already included above
// #include "interaction_msgs/srv/detail/query__functions.h"
// already included above
// #include "fastcdr/Cdr.h"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif
#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// includes and forward declarations of message dependencies and their conversion functions

#if defined(__cplusplus)
extern "C"
{
#endif


// forward declare type support functions


using _Query_Response__ros_msg_type = interaction_msgs__srv__Query_Response;

static bool _Query_Response__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  const _Query_Response__ros_msg_type * ros_message = static_cast<const _Query_Response__ros_msg_type *>(untyped_ros_message);
  // Field name: interaction
  {
    cdr << (ros_message->interaction ? true : false);
  }

  return true;
}

static bool _Query_Response__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  _Query_Response__ros_msg_type * ros_message = static_cast<_Query_Response__ros_msg_type *>(untyped_ros_message);
  // Field name: interaction
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message->interaction = tmp ? true : false;
  }

  return true;
}  // NOLINT(readability/fn_size)

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_interaction_msgs
size_t get_serialized_size_interaction_msgs__srv__Query_Response(
  const void * untyped_ros_message,
  size_t current_alignment)
{
  const _Query_Response__ros_msg_type * ros_message = static_cast<const _Query_Response__ros_msg_type *>(untyped_ros_message);
  (void)ros_message;
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // field.name interaction
  {
    size_t item_size = sizeof(ros_message->interaction);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

static uint32_t _Query_Response__get_serialized_size(const void * untyped_ros_message)
{
  return static_cast<uint32_t>(
    get_serialized_size_interaction_msgs__srv__Query_Response(
      untyped_ros_message, 0));
}

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_interaction_msgs
size_t max_serialized_size_interaction_msgs__srv__Query_Response(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;

  // member: interaction
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = interaction_msgs__srv__Query_Response;
    is_plain =
      (
      offsetof(DataType, interaction) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static size_t _Query_Response__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_interaction_msgs__srv__Query_Response(
    full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}


static message_type_support_callbacks_t __callbacks_Query_Response = {
  "interaction_msgs::srv",
  "Query_Response",
  _Query_Response__cdr_serialize,
  _Query_Response__cdr_deserialize,
  _Query_Response__get_serialized_size,
  _Query_Response__max_serialized_size
};

static rosidl_message_type_support_t _Query_Response__type_support = {
  rosidl_typesupport_fastrtps_c__identifier,
  &__callbacks_Query_Response,
  get_message_typesupport_handle_function,
};

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, interaction_msgs, srv, Query_Response)() {
  return &_Query_Response__type_support;
}

#if defined(__cplusplus)
}
#endif

#include "rosidl_typesupport_fastrtps_cpp/service_type_support.h"
#include "rosidl_typesupport_cpp/service_type_support.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_c/identifier.h"
// already included above
// #include "interaction_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
#include "interaction_msgs/srv/query.h"

#if defined(__cplusplus)
extern "C"
{
#endif

static service_type_support_callbacks_t Query__callbacks = {
  "interaction_msgs::srv",
  "Query",
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, interaction_msgs, srv, Query_Request)(),
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, interaction_msgs, srv, Query_Response)(),
};

static rosidl_service_type_support_t Query__handle = {
  rosidl_typesupport_fastrtps_c__identifier,
  &Query__callbacks,
  get_service_typesupport_handle_function,
};

const rosidl_service_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__SERVICE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, interaction_msgs, srv, Query)() {
  return &Query__handle;
}

#if defined(__cplusplus)
}
#endif
