// generated from rosidl_typesupport_fastrtps_c/resource/idl__type_support_c.cpp.em
// with input from interaction_msgs:srv/Task.idl
// generated code does not contain a copyright notice
#include "interaction_msgs/srv/detail/task__rosidl_typesupport_fastrtps_c.h"


#include <cassert>
#include <limits>
#include <string>
#include "rosidl_typesupport_fastrtps_c/identifier.h"
#include "rosidl_typesupport_fastrtps_c/wstring_conversion.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "interaction_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
#include "interaction_msgs/srv/detail/task__struct.h"
#include "interaction_msgs/srv/detail/task__functions.h"
#include "fastcdr/Cdr.h"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif
#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// includes and forward declarations of message dependencies and their conversion functions

#if defined(__cplusplus)
extern "C"
{
#endif

#include "rosidl_runtime_c/primitives_sequence.h"  // x_next
#include "rosidl_runtime_c/primitives_sequence_functions.h"  // x_next

// forward declare type support functions


using _Task_Request__ros_msg_type = interaction_msgs__srv__Task_Request;

static bool _Task_Request__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  const _Task_Request__ros_msg_type * ros_message = static_cast<const _Task_Request__ros_msg_type *>(untyped_ros_message);
  // Field name: reward_return
  {
    cdr << (ros_message->reward_return ? true : false);
  }

  // Field name: nr_dim
  {
    cdr << ros_message->nr_dim;
  }

  // Field name: nr_parameter
  {
    cdr << ros_message->nr_parameter;
  }

  // Field name: x_next
  {
    size_t size = ros_message->x_next.size;
    auto array_ptr = ros_message->x_next.data;
    cdr << static_cast<uint32_t>(size);
    cdr.serializeArray(array_ptr, size);
  }

  return true;
}

static bool _Task_Request__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  _Task_Request__ros_msg_type * ros_message = static_cast<_Task_Request__ros_msg_type *>(untyped_ros_message);
  // Field name: reward_return
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message->reward_return = tmp ? true : false;
  }

  // Field name: nr_dim
  {
    cdr >> ros_message->nr_dim;
  }

  // Field name: nr_parameter
  {
    cdr >> ros_message->nr_parameter;
  }

  // Field name: x_next
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    if (ros_message->x_next.data) {
      rosidl_runtime_c__float__Sequence__fini(&ros_message->x_next);
    }
    if (!rosidl_runtime_c__float__Sequence__init(&ros_message->x_next, size)) {
      fprintf(stderr, "failed to create array for field 'x_next'");
      return false;
    }
    auto array_ptr = ros_message->x_next.data;
    cdr.deserializeArray(array_ptr, size);
  }

  return true;
}  // NOLINT(readability/fn_size)

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_interaction_msgs
size_t get_serialized_size_interaction_msgs__srv__Task_Request(
  const void * untyped_ros_message,
  size_t current_alignment)
{
  const _Task_Request__ros_msg_type * ros_message = static_cast<const _Task_Request__ros_msg_type *>(untyped_ros_message);
  (void)ros_message;
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // field.name reward_return
  {
    size_t item_size = sizeof(ros_message->reward_return);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // field.name nr_dim
  {
    size_t item_size = sizeof(ros_message->nr_dim);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // field.name nr_parameter
  {
    size_t item_size = sizeof(ros_message->nr_parameter);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // field.name x_next
  {
    size_t array_size = ros_message->x_next.size;
    auto array_ptr = ros_message->x_next.data;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);
    (void)array_ptr;
    size_t item_size = sizeof(array_ptr[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

static uint32_t _Task_Request__get_serialized_size(const void * untyped_ros_message)
{
  return static_cast<uint32_t>(
    get_serialized_size_interaction_msgs__srv__Task_Request(
      untyped_ros_message, 0));
}

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_interaction_msgs
size_t max_serialized_size_interaction_msgs__srv__Task_Request(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;

  // member: reward_return
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }
  // member: nr_dim
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint16_t);
    current_alignment += array_size * sizeof(uint16_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint16_t));
  }
  // member: nr_parameter
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint16_t);
    current_alignment += array_size * sizeof(uint16_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint16_t));
  }
  // member: x_next
  {
    size_t array_size = 0;
    full_bounded = false;
    is_plain = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = interaction_msgs__srv__Task_Request;
    is_plain =
      (
      offsetof(DataType, x_next) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static size_t _Task_Request__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_interaction_msgs__srv__Task_Request(
    full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}


static message_type_support_callbacks_t __callbacks_Task_Request = {
  "interaction_msgs::srv",
  "Task_Request",
  _Task_Request__cdr_serialize,
  _Task_Request__cdr_deserialize,
  _Task_Request__get_serialized_size,
  _Task_Request__max_serialized_size
};

static rosidl_message_type_support_t _Task_Request__type_support = {
  rosidl_typesupport_fastrtps_c__identifier,
  &__callbacks_Task_Request,
  get_message_typesupport_handle_function,
};

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, interaction_msgs, srv, Task_Request)() {
  return &_Task_Request__type_support;
}

#if defined(__cplusplus)
}
#endif

// already included above
// #include <cassert>
// already included above
// #include <limits>
// already included above
// #include <string>
// already included above
// #include "rosidl_typesupport_fastrtps_c/identifier.h"
// already included above
// #include "rosidl_typesupport_fastrtps_c/wstring_conversion.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
// already included above
// #include "interaction_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
// already included above
// #include "interaction_msgs/srv/detail/task__struct.h"
// already included above
// #include "interaction_msgs/srv/detail/task__functions.h"
// already included above
// #include "fastcdr/Cdr.h"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif
#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// includes and forward declarations of message dependencies and their conversion functions

#if defined(__cplusplus)
extern "C"
{
#endif

// already included above
// #include "rosidl_runtime_c/primitives_sequence.h"  // x_observed
// already included above
// #include "rosidl_runtime_c/primitives_sequence_functions.h"  // x_observed

// forward declare type support functions


using _Task_Response__ros_msg_type = interaction_msgs__srv__Task_Response;

static bool _Task_Response__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  const _Task_Response__ros_msg_type * ros_message = static_cast<const _Task_Response__ros_msg_type *>(untyped_ros_message);
  // Field name: x_observed
  {
    size_t size = ros_message->x_observed.size;
    auto array_ptr = ros_message->x_observed.data;
    cdr << static_cast<uint32_t>(size);
    cdr.serializeArray(array_ptr, size);
  }

  // Field name: reward
  {
    cdr << ros_message->reward;
  }

  return true;
}

static bool _Task_Response__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  _Task_Response__ros_msg_type * ros_message = static_cast<_Task_Response__ros_msg_type *>(untyped_ros_message);
  // Field name: x_observed
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    if (ros_message->x_observed.data) {
      rosidl_runtime_c__float__Sequence__fini(&ros_message->x_observed);
    }
    if (!rosidl_runtime_c__float__Sequence__init(&ros_message->x_observed, size)) {
      fprintf(stderr, "failed to create array for field 'x_observed'");
      return false;
    }
    auto array_ptr = ros_message->x_observed.data;
    cdr.deserializeArray(array_ptr, size);
  }

  // Field name: reward
  {
    cdr >> ros_message->reward;
  }

  return true;
}  // NOLINT(readability/fn_size)

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_interaction_msgs
size_t get_serialized_size_interaction_msgs__srv__Task_Response(
  const void * untyped_ros_message,
  size_t current_alignment)
{
  const _Task_Response__ros_msg_type * ros_message = static_cast<const _Task_Response__ros_msg_type *>(untyped_ros_message);
  (void)ros_message;
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // field.name x_observed
  {
    size_t array_size = ros_message->x_observed.size;
    auto array_ptr = ros_message->x_observed.data;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);
    (void)array_ptr;
    size_t item_size = sizeof(array_ptr[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // field.name reward
  {
    size_t item_size = sizeof(ros_message->reward);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

static uint32_t _Task_Response__get_serialized_size(const void * untyped_ros_message)
{
  return static_cast<uint32_t>(
    get_serialized_size_interaction_msgs__srv__Task_Response(
      untyped_ros_message, 0));
}

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_interaction_msgs
size_t max_serialized_size_interaction_msgs__srv__Task_Response(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;

  // member: x_observed
  {
    size_t array_size = 0;
    full_bounded = false;
    is_plain = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }
  // member: reward
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = interaction_msgs__srv__Task_Response;
    is_plain =
      (
      offsetof(DataType, reward) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static size_t _Task_Response__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_interaction_msgs__srv__Task_Response(
    full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}


static message_type_support_callbacks_t __callbacks_Task_Response = {
  "interaction_msgs::srv",
  "Task_Response",
  _Task_Response__cdr_serialize,
  _Task_Response__cdr_deserialize,
  _Task_Response__get_serialized_size,
  _Task_Response__max_serialized_size
};

static rosidl_message_type_support_t _Task_Response__type_support = {
  rosidl_typesupport_fastrtps_c__identifier,
  &__callbacks_Task_Response,
  get_message_typesupport_handle_function,
};

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, interaction_msgs, srv, Task_Response)() {
  return &_Task_Response__type_support;
}

#if defined(__cplusplus)
}
#endif

#include "rosidl_typesupport_fastrtps_cpp/service_type_support.h"
#include "rosidl_typesupport_cpp/service_type_support.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_c/identifier.h"
// already included above
// #include "interaction_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
#include "interaction_msgs/srv/task.h"

#if defined(__cplusplus)
extern "C"
{
#endif

static service_type_support_callbacks_t Task__callbacks = {
  "interaction_msgs::srv",
  "Task",
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, interaction_msgs, srv, Task_Request)(),
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, interaction_msgs, srv, Task_Response)(),
};

static rosidl_service_type_support_t Task__handle = {
  rosidl_typesupport_fastrtps_c__identifier,
  &Task__callbacks,
  get_service_typesupport_handle_function,
};

const rosidl_service_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__SERVICE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, interaction_msgs, srv, Task)() {
  return &Task__handle;
}

#if defined(__cplusplus)
}
#endif
