// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from interaction_msgs:msg/OptimizerState.idl
// generated code does not contain a copyright notice
#include "interaction_msgs/msg/detail/optimizer_state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `current_state`
#include "rosidl_runtime_c/string_functions.h"
// Member `x_best`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
interaction_msgs__msg__OptimizerState__init(interaction_msgs__msg__OptimizerState * msg)
{
  if (!msg) {
    return false;
  }
  // current_state
  if (!rosidl_runtime_c__String__init(&msg->current_state)) {
    interaction_msgs__msg__OptimizerState__fini(msg);
    return false;
  }
  // current_episode
  // reward_best
  // x_best
  if (!rosidl_runtime_c__float__Sequence__init(&msg->x_best, 0)) {
    interaction_msgs__msg__OptimizerState__fini(msg);
    return false;
  }
  return true;
}

void
interaction_msgs__msg__OptimizerState__fini(interaction_msgs__msg__OptimizerState * msg)
{
  if (!msg) {
    return;
  }
  // current_state
  rosidl_runtime_c__String__fini(&msg->current_state);
  // current_episode
  // reward_best
  // x_best
  rosidl_runtime_c__float__Sequence__fini(&msg->x_best);
}

bool
interaction_msgs__msg__OptimizerState__are_equal(const interaction_msgs__msg__OptimizerState * lhs, const interaction_msgs__msg__OptimizerState * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // current_state
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->current_state), &(rhs->current_state)))
  {
    return false;
  }
  // current_episode
  if (lhs->current_episode != rhs->current_episode) {
    return false;
  }
  // reward_best
  if (lhs->reward_best != rhs->reward_best) {
    return false;
  }
  // x_best
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->x_best), &(rhs->x_best)))
  {
    return false;
  }
  return true;
}

bool
interaction_msgs__msg__OptimizerState__copy(
  const interaction_msgs__msg__OptimizerState * input,
  interaction_msgs__msg__OptimizerState * output)
{
  if (!input || !output) {
    return false;
  }
  // current_state
  if (!rosidl_runtime_c__String__copy(
      &(input->current_state), &(output->current_state)))
  {
    return false;
  }
  // current_episode
  output->current_episode = input->current_episode;
  // reward_best
  output->reward_best = input->reward_best;
  // x_best
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->x_best), &(output->x_best)))
  {
    return false;
  }
  return true;
}

interaction_msgs__msg__OptimizerState *
interaction_msgs__msg__OptimizerState__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  interaction_msgs__msg__OptimizerState * msg = (interaction_msgs__msg__OptimizerState *)allocator.allocate(sizeof(interaction_msgs__msg__OptimizerState), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(interaction_msgs__msg__OptimizerState));
  bool success = interaction_msgs__msg__OptimizerState__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
interaction_msgs__msg__OptimizerState__destroy(interaction_msgs__msg__OptimizerState * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    interaction_msgs__msg__OptimizerState__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
interaction_msgs__msg__OptimizerState__Sequence__init(interaction_msgs__msg__OptimizerState__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  interaction_msgs__msg__OptimizerState * data = NULL;

  if (size) {
    data = (interaction_msgs__msg__OptimizerState *)allocator.zero_allocate(size, sizeof(interaction_msgs__msg__OptimizerState), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = interaction_msgs__msg__OptimizerState__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        interaction_msgs__msg__OptimizerState__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
interaction_msgs__msg__OptimizerState__Sequence__fini(interaction_msgs__msg__OptimizerState__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      interaction_msgs__msg__OptimizerState__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

interaction_msgs__msg__OptimizerState__Sequence *
interaction_msgs__msg__OptimizerState__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  interaction_msgs__msg__OptimizerState__Sequence * array = (interaction_msgs__msg__OptimizerState__Sequence *)allocator.allocate(sizeof(interaction_msgs__msg__OptimizerState__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = interaction_msgs__msg__OptimizerState__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
interaction_msgs__msg__OptimizerState__Sequence__destroy(interaction_msgs__msg__OptimizerState__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    interaction_msgs__msg__OptimizerState__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
interaction_msgs__msg__OptimizerState__Sequence__are_equal(const interaction_msgs__msg__OptimizerState__Sequence * lhs, const interaction_msgs__msg__OptimizerState__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!interaction_msgs__msg__OptimizerState__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
interaction_msgs__msg__OptimizerState__Sequence__copy(
  const interaction_msgs__msg__OptimizerState__Sequence * input,
  interaction_msgs__msg__OptimizerState__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(interaction_msgs__msg__OptimizerState);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    interaction_msgs__msg__OptimizerState * data =
      (interaction_msgs__msg__OptimizerState *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!interaction_msgs__msg__OptimizerState__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          interaction_msgs__msg__OptimizerState__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!interaction_msgs__msg__OptimizerState__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
