// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from interaction_msgs:msg/UI2Opt.idl
// generated code does not contain a copyright notice

#ifndef INTERACTION_MSGS__MSG__DETAIL__UI2_OPT__FUNCTIONS_H_
#define INTERACTION_MSGS__MSG__DETAIL__UI2_OPT__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "interaction_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "interaction_msgs/msg/detail/ui2_opt__struct.h"

/// Initialize msg/UI2Opt message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * interaction_msgs__msg__UI2Opt
 * )) before or use
 * interaction_msgs__msg__UI2Opt__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
bool
interaction_msgs__msg__UI2Opt__init(interaction_msgs__msg__UI2Opt * msg);

/// Finalize msg/UI2Opt message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
void
interaction_msgs__msg__UI2Opt__fini(interaction_msgs__msg__UI2Opt * msg);

/// Create msg/UI2Opt message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * interaction_msgs__msg__UI2Opt__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
interaction_msgs__msg__UI2Opt *
interaction_msgs__msg__UI2Opt__create();

/// Destroy msg/UI2Opt message.
/**
 * It calls
 * interaction_msgs__msg__UI2Opt__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
void
interaction_msgs__msg__UI2Opt__destroy(interaction_msgs__msg__UI2Opt * msg);

/// Check for msg/UI2Opt message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
bool
interaction_msgs__msg__UI2Opt__are_equal(const interaction_msgs__msg__UI2Opt * lhs, const interaction_msgs__msg__UI2Opt * rhs);

/// Copy a msg/UI2Opt message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
bool
interaction_msgs__msg__UI2Opt__copy(
  const interaction_msgs__msg__UI2Opt * input,
  interaction_msgs__msg__UI2Opt * output);

/// Initialize array of msg/UI2Opt messages.
/**
 * It allocates the memory for the number of elements and calls
 * interaction_msgs__msg__UI2Opt__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
bool
interaction_msgs__msg__UI2Opt__Sequence__init(interaction_msgs__msg__UI2Opt__Sequence * array, size_t size);

/// Finalize array of msg/UI2Opt messages.
/**
 * It calls
 * interaction_msgs__msg__UI2Opt__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
void
interaction_msgs__msg__UI2Opt__Sequence__fini(interaction_msgs__msg__UI2Opt__Sequence * array);

/// Create array of msg/UI2Opt messages.
/**
 * It allocates the memory for the array and calls
 * interaction_msgs__msg__UI2Opt__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
interaction_msgs__msg__UI2Opt__Sequence *
interaction_msgs__msg__UI2Opt__Sequence__create(size_t size);

/// Destroy array of msg/UI2Opt messages.
/**
 * It calls
 * interaction_msgs__msg__UI2Opt__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
void
interaction_msgs__msg__UI2Opt__Sequence__destroy(interaction_msgs__msg__UI2Opt__Sequence * array);

/// Check for msg/UI2Opt message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
bool
interaction_msgs__msg__UI2Opt__Sequence__are_equal(const interaction_msgs__msg__UI2Opt__Sequence * lhs, const interaction_msgs__msg__UI2Opt__Sequence * rhs);

/// Copy an array of msg/UI2Opt messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_interaction_msgs
bool
interaction_msgs__msg__UI2Opt__Sequence__copy(
  const interaction_msgs__msg__UI2Opt__Sequence * input,
  interaction_msgs__msg__UI2Opt__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // INTERACTION_MSGS__MSG__DETAIL__UI2_OPT__FUNCTIONS_H_
