// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from interaction_msgs:srv/Query.idl
// generated code does not contain a copyright notice

#ifndef INTERACTION_MSGS__SRV__DETAIL__QUERY__STRUCT_H_
#define INTERACTION_MSGS__SRV__DETAIL__QUERY__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'last_rewards'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in srv/Query in the package interaction_msgs.
typedef struct interaction_msgs__srv__Query_Request
{
  uint16_t modes;
  /// random query
  float threshold;
  /// regular query
  uint16_t frequency;
  uint16_t current_episode;
  /// improvement query
  /// float32 threshold
  /// uint16 frequency
  uint16_t last_queried_episode;
  rosidl_runtime_c__float__Sequence last_rewards;
} interaction_msgs__srv__Query_Request;

// Struct for a sequence of interaction_msgs__srv__Query_Request.
typedef struct interaction_msgs__srv__Query_Request__Sequence
{
  interaction_msgs__srv__Query_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} interaction_msgs__srv__Query_Request__Sequence;


// Constants defined in the message

/// Struct defined in srv/Query in the package interaction_msgs.
typedef struct interaction_msgs__srv__Query_Response
{
  bool interaction;
} interaction_msgs__srv__Query_Response;

// Struct for a sequence of interaction_msgs__srv__Query_Response.
typedef struct interaction_msgs__srv__Query_Response__Sequence
{
  interaction_msgs__srv__Query_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} interaction_msgs__srv__Query_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // INTERACTION_MSGS__SRV__DETAIL__QUERY__STRUCT_H_
