// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from interaction_msgs:srv/Task.idl
// generated code does not contain a copyright notice

#ifndef INTERACTION_MSGS__SRV__DETAIL__TASK__STRUCT_H_
#define INTERACTION_MSGS__SRV__DETAIL__TASK__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'x_next'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in srv/Task in the package interaction_msgs.
typedef struct interaction_msgs__srv__Task_Request
{
  bool reward_return;
  /// Number of dimensions of the representation model
  uint16_t nr_dim;
  /// Number of parameters per dimensions
  uint16_t nr_parameter;
  /// Next parameters
  rosidl_runtime_c__float__Sequence x_next;
} interaction_msgs__srv__Task_Request;

// Struct for a sequence of interaction_msgs__srv__Task_Request.
typedef struct interaction_msgs__srv__Task_Request__Sequence
{
  interaction_msgs__srv__Task_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} interaction_msgs__srv__Task_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'x_observed'
// already included above
// #include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in srv/Task in the package interaction_msgs.
typedef struct interaction_msgs__srv__Task_Response
{
  rosidl_runtime_c__float__Sequence x_observed;
  /// observed reward
  float reward;
} interaction_msgs__srv__Task_Response;

// Struct for a sequence of interaction_msgs__srv__Task_Response.
typedef struct interaction_msgs__srv__Task_Response__Sequence
{
  interaction_msgs__srv__Task_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} interaction_msgs__srv__Task_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // INTERACTION_MSGS__SRV__DETAIL__TASK__STRUCT_H_
