// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from interaction_msgs:srv/Task.idl
// generated code does not contain a copyright notice

#ifndef INTERACTION_MSGS__SRV__DETAIL__TASK__TRAITS_HPP_
#define INTERACTION_MSGS__SRV__DETAIL__TASK__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "interaction_msgs/srv/detail/task__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace interaction_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const Task_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: reward_return
  {
    out << "reward_return: ";
    rosidl_generator_traits::value_to_yaml(msg.reward_return, out);
    out << ", ";
  }

  // member: nr_dim
  {
    out << "nr_dim: ";
    rosidl_generator_traits::value_to_yaml(msg.nr_dim, out);
    out << ", ";
  }

  // member: nr_parameter
  {
    out << "nr_parameter: ";
    rosidl_generator_traits::value_to_yaml(msg.nr_parameter, out);
    out << ", ";
  }

  // member: x_next
  {
    if (msg.x_next.size() == 0) {
      out << "x_next: []";
    } else {
      out << "x_next: [";
      size_t pending_items = msg.x_next.size();
      for (auto item : msg.x_next) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Task_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: reward_return
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "reward_return: ";
    rosidl_generator_traits::value_to_yaml(msg.reward_return, out);
    out << "\n";
  }

  // member: nr_dim
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "nr_dim: ";
    rosidl_generator_traits::value_to_yaml(msg.nr_dim, out);
    out << "\n";
  }

  // member: nr_parameter
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "nr_parameter: ";
    rosidl_generator_traits::value_to_yaml(msg.nr_parameter, out);
    out << "\n";
  }

  // member: x_next
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.x_next.size() == 0) {
      out << "x_next: []\n";
    } else {
      out << "x_next:\n";
      for (auto item : msg.x_next) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Task_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace interaction_msgs

namespace rosidl_generator_traits
{

[[deprecated("use interaction_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const interaction_msgs::srv::Task_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  interaction_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use interaction_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const interaction_msgs::srv::Task_Request & msg)
{
  return interaction_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<interaction_msgs::srv::Task_Request>()
{
  return "interaction_msgs::srv::Task_Request";
}

template<>
inline const char * name<interaction_msgs::srv::Task_Request>()
{
  return "interaction_msgs/srv/Task_Request";
}

template<>
struct has_fixed_size<interaction_msgs::srv::Task_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<interaction_msgs::srv::Task_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<interaction_msgs::srv::Task_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace interaction_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const Task_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: x_observed
  {
    if (msg.x_observed.size() == 0) {
      out << "x_observed: []";
    } else {
      out << "x_observed: [";
      size_t pending_items = msg.x_observed.size();
      for (auto item : msg.x_observed) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: reward
  {
    out << "reward: ";
    rosidl_generator_traits::value_to_yaml(msg.reward, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Task_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: x_observed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.x_observed.size() == 0) {
      out << "x_observed: []\n";
    } else {
      out << "x_observed:\n";
      for (auto item : msg.x_observed) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: reward
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "reward: ";
    rosidl_generator_traits::value_to_yaml(msg.reward, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Task_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace interaction_msgs

namespace rosidl_generator_traits
{

[[deprecated("use interaction_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const interaction_msgs::srv::Task_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  interaction_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use interaction_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const interaction_msgs::srv::Task_Response & msg)
{
  return interaction_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<interaction_msgs::srv::Task_Response>()
{
  return "interaction_msgs::srv::Task_Response";
}

template<>
inline const char * name<interaction_msgs::srv::Task_Response>()
{
  return "interaction_msgs/srv/Task_Response";
}

template<>
struct has_fixed_size<interaction_msgs::srv::Task_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<interaction_msgs::srv::Task_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<interaction_msgs::srv::Task_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<interaction_msgs::srv::Task>()
{
  return "interaction_msgs::srv::Task";
}

template<>
inline const char * name<interaction_msgs::srv::Task>()
{
  return "interaction_msgs/srv/Task";
}

template<>
struct has_fixed_size<interaction_msgs::srv::Task>
  : std::integral_constant<
    bool,
    has_fixed_size<interaction_msgs::srv::Task_Request>::value &&
    has_fixed_size<interaction_msgs::srv::Task_Response>::value
  >
{
};

template<>
struct has_bounded_size<interaction_msgs::srv::Task>
  : std::integral_constant<
    bool,
    has_bounded_size<interaction_msgs::srv::Task_Request>::value &&
    has_bounded_size<interaction_msgs::srv::Task_Response>::value
  >
{
};

template<>
struct is_service<interaction_msgs::srv::Task>
  : std::true_type
{
};

template<>
struct is_service_request<interaction_msgs::srv::Task_Request>
  : std::true_type
{
};

template<>
struct is_service_response<interaction_msgs::srv::Task_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // INTERACTION_MSGS__SRV__DETAIL__TASK__TRAITS_HPP_
